"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _providers = _interopRequireDefault(require("lib/providers"));

var _utils = _interopRequireDefault(require("utils"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _package = require("../package.json");

var _transactionBuilder = _interopRequireDefault(require("lib/transactionBuilder"));

var _mcash = _interopRequireDefault(require("lib/mcash"));

var _contract = _interopRequireDefault(require("lib/contract"));

var _plugin = _interopRequireDefault(require("lib/plugin"));

var _event = _interopRequireDefault(require("lib/event"));

var _ethersUtils = require("utils/ethersUtils");

var _address = require("utils/address");

var McashWeb =
/*#__PURE__*/
function (_EventEmitter) {
  (0, _inherits2["default"])(McashWeb, _EventEmitter);

  function McashWeb() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var solidityNode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var eventServer = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var privateKey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    (0, _classCallCheck2["default"])(this, McashWeb);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(McashWeb).call(this));
    var fullNode;

    if ((0, _typeof2["default"])(options) === 'object' && (options.fullNode || options.fullHost)) {
      fullNode = options.fullNode || options.fullHost;
      solidityNode = options.solidityNode || options.fullHost;
      eventServer = options.eventServer || options.fullHost;
      privateKey = options.privateKey;
    } else {
      fullNode = options;
    }

    if (_utils["default"].isString(fullNode)) fullNode = new _providers["default"].HttpProvider(fullNode);
    if (_utils["default"].isString(solidityNode)) solidityNode = new _providers["default"].HttpProvider(solidityNode);
    if (_utils["default"].isString(eventServer)) eventServer = new _providers["default"].HttpProvider(eventServer);
    _this.event = new _event["default"]((0, _assertThisInitialized2["default"])(_this));
    _this.transactionBuilder = new _transactionBuilder["default"]((0, _assertThisInitialized2["default"])(_this));
    _this.mcash = new _mcash["default"]((0, _assertThisInitialized2["default"])(_this));
    _this.plugin = new _plugin["default"]((0, _assertThisInitialized2["default"])(_this));
    _this.utils = _utils["default"];

    _this.setFullNode(fullNode);

    _this.setSolidityNode(solidityNode);

    _this.setEventServer(eventServer);

    _this.providers = _providers["default"];
    _this.BigNumber = _bignumber["default"];
    _this.defaultBlock = false;
    _this.defaultPrivateKey = false;
    _this.defaultAddress = {
      hex: false,
      base58: false
    };
    ['sha3', 'toHex', 'toUtf8', 'fromUtf8', 'toAscii', 'fromAscii', 'toDecimal', 'fromDecimal', 'toSun', 'fromSun', 'toBigNumber', 'isAddress', 'createAccount', 'address', 'version'].forEach(function (key) {
      _this[key] = McashWeb[key];
    });
    if (privateKey) _this.setPrivateKey(privateKey);
    _this.injectPromise = _utils["default"].promiseInjector((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(McashWeb, [{
    key: "setDefaultBlock",
    value: function setDefaultBlock() {
      var blockID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if ([false, 'latest', 'earliest', 0].includes(blockID)) {
        return this.defaultBlock = blockID;
      }

      if (!_utils["default"].isInteger(blockID) || !blockID) throw new Error('Invalid block ID provided');
      this.defaultBlock = Math.abs(blockID);
    }
  }, {
    key: "setPrivateKey",
    value: function setPrivateKey(privateKey) {
      try {
        this.setAddress(this.address.fromPrivateKey(privateKey));
      } catch (_unused) {
        throw new Error('Invalid private key provided');
      }

      this.defaultPrivateKey = privateKey;
      this.emit('privateKeyChanged', privateKey);
    }
  }, {
    key: "setAddress",
    value: function setAddress(address) {
      if (!this.isAddress(address)) throw new Error('Invalid address provided');
      var hex = this.address.toHex(address);
      var base58 = this.address.fromHex(address);
      if (this.defaultPrivateKey && this.address.fromPrivateKey(this.defaultPrivateKey) !== base58) this.defaultPrivateKey = false;
      this.defaultAddress = {
        hex: hex,
        base58: base58
      };
      this.emit('addressChanged', {
        hex: hex,
        base58: base58
      });
    }
  }, {
    key: "isValidProvider",
    value: function isValidProvider(provider) {
      return Object.values(_providers["default"]).some(function (knownProvider) {
        return provider instanceof knownProvider;
      });
    }
  }, {
    key: "setFullNode",
    value: function setFullNode(fullNode) {
      if (_utils["default"].isString(fullNode)) fullNode = new _providers["default"].HttpProvider(fullNode);
      if (!this.isValidProvider(fullNode)) throw new Error('Invalid full node provided');
      this.fullNode = fullNode;
      this.fullNode.setStatusPage('wallet/getnowblock');
    }
  }, {
    key: "setSolidityNode",
    value: function setSolidityNode(solidityNode) {
      if (_utils["default"].isString(solidityNode)) solidityNode = new _providers["default"].HttpProvider(solidityNode);
      if (!this.isValidProvider(solidityNode)) throw new Error('Invalid solidity node provided');
      this.solidityNode = solidityNode;
      this.solidityNode.setStatusPage('walletsolidity/getnowblock');
    }
  }, {
    key: "setEventServer",
    value: function setEventServer() {
      var _this$event;

      (_this$event = this.event).setServer.apply(_this$event, arguments);
    }
  }, {
    key: "currentProviders",
    value: function currentProviders() {
      return {
        fullNode: this.fullNode,
        solidityNode: this.solidityNode,
        eventServer: this.eventServer
      };
    }
  }, {
    key: "currentProvider",
    value: function currentProvider() {
      return this.currentProviders();
    }
  }, {
    key: "getEventResult",
    value: function getEventResult() {
      var _this$event2;

      for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
        params[_key] = arguments[_key];
      }

      if ((0, _typeof2["default"])(params[1]) !== 'object') {
        params[1] = {
          sinceTimestamp: params[1] || 0,
          eventName: params[2] || false,
          blockNumber: params[3] || false,
          size: params[4] || 20,
          page: params[5] || 1
        };
        params.splice(2, 4); // callback:

        if (!_utils["default"].isFunction(params[2])) {
          if (_utils["default"].isFunction(params[1].page)) {
            params[2] = params[1].page;
            params[1].page = 1;
          } else if (_utils["default"].isFunction(params[1].size)) {
            params[2] = params[1].size;
            params[1].size = 20;
            params[1].page = 1;
          }
        }
      }

      return (_this$event2 = this.event).getEventsByContractAddress.apply(_this$event2, params);
    }
  }, {
    key: "getEventByTransactionID",
    value: function getEventByTransactionID() {
      var _this$event3;

      return (_this$event3 = this.event).getEventsByTransactionID.apply(_this$event3, arguments);
    }
  }, {
    key: "contract",
    value: function contract() {
      var abi = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var address = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      return new _contract["default"](this, abi, address);
    }
  }, {
    key: "isConnected",
    value: function () {
      var _isConnected = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var callback,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                callback = _args.length > 0 && _args[0] !== undefined ? _args[0] : false;

                if (callback) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return", this.injectPromise(this.isConnected));

              case 3:
                _context.t0 = callback;
                _context.next = 6;
                return this.fullNode.isConnected();

              case 6:
                _context.t1 = _context.sent;
                _context.next = 9;
                return this.solidityNode.isConnected();

              case 9:
                _context.t2 = _context.sent;
                _context.t3 = this.eventServer;

                if (!_context.t3) {
                  _context.next = 15;
                  break;
                }

                _context.next = 14;
                return this.eventServer.isConnected();

              case 14:
                _context.t3 = _context.sent;

              case 15:
                _context.t4 = _context.t3;
                _context.t5 = {
                  fullNode: _context.t1,
                  solidityNode: _context.t2,
                  eventServer: _context.t4
                };
                return _context.abrupt("return", (0, _context.t0)(null, _context.t5));

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function isConnected() {
        return _isConnected.apply(this, arguments);
      }

      return isConnected;
    }()
  }], [{
    key: "sha3",
    value: function sha3(string) {
      var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      return (prefix ? '0x' : '') + (0, _ethersUtils.keccak256)(Buffer.from(string, 'utf-8')).toString().substring(2);
    }
  }, {
    key: "toHex",
    value: function toHex(val) {
      if (_utils["default"].isBoolean(val)) return McashWeb.fromDecimal(+val);
      if (_utils["default"].isBigNumber(val)) return McashWeb.fromDecimal(val);
      if ((0, _typeof2["default"])(val) === 'object') return McashWeb.fromUtf8(JSON.stringify(val));

      if (_utils["default"].isString(val)) {
        if (/^(-|)0x/.test(val)) return val;
        if (!isFinite(val)) return McashWeb.fromUtf8(val);
      }

      var result = McashWeb.fromDecimal(val);

      if (result === '0xNaN') {
        throw new Error('The passed value is not convertible to a hex string');
      } else {
        return result;
      }
    }
  }, {
    key: "toUtf8",
    value: function toUtf8(hex) {
      if (_utils["default"].isHex(hex)) {
        hex = hex.replace(/^0x/, '');
        return Buffer.from(hex, 'hex').toString('utf8');
      } else {
        throw new Error('The passed value is not a valid hex string');
      }
    }
  }, {
    key: "fromUtf8",
    value: function fromUtf8(string) {
      if (!_utils["default"].isString(string)) {
        throw new Error('The passed value is not a valid utf-8 string');
      }

      return '0x' + Buffer.from(string, 'utf8').toString('hex');
    }
  }, {
    key: "toAscii",
    value: function toAscii(hex) {
      if (_utils["default"].isHex(hex)) {
        var str = "";
        var i = 0,
            l = hex.length;

        if (hex.substring(0, 2) === '0x') {
          i = 2;
        }

        for (; i < l; i += 2) {
          var code = parseInt(hex.substr(i, 2), 16);
          str += String.fromCharCode(code);
        }

        return str;
      } else {
        throw new Error('The passed value is not a valid hex string');
      }
    }
  }, {
    key: "fromAscii",
    value: function fromAscii(string, padding) {
      if (!_utils["default"].isString(string)) {
        throw new Error('The passed value is not a valid utf-8 string');
      }

      return '0x' + Buffer.from(string, 'ascii').toString('hex').padEnd(padding, '0');
    }
  }, {
    key: "toDecimal",
    value: function toDecimal(value) {
      return McashWeb.toBigNumber(value).toNumber();
    }
  }, {
    key: "fromDecimal",
    value: function fromDecimal(value) {
      var number = McashWeb.toBigNumber(value);
      var result = number.toString(16);
      return number.isLessThan(0) ? '-0x' + result.substr(1) : '0x' + result;
    }
  }, {
    key: "fromMatoshi",
    value: function fromMatoshi(matoshi) {
      var mcash = McashWeb.toBigNumber(matoshi).div(100000000);
      return _utils["default"].isBigNumber(matoshi) ? mcash : mcash.toString(10);
    }
  }, {
    key: "toMatoshi",
    value: function toMatoshi(mcash) {
      var matoshi = McashWeb.toBigNumber(mcash).times(100000000);
      return _utils["default"].isBigNumber(mcash) ? matoshi : matoshi.toString(10);
    }
  }, {
    key: "toBigNumber",
    value: function toBigNumber() {
      var amount = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      if (_utils["default"].isBigNumber(amount)) return amount;
      if (_utils["default"].isString(amount) && /^(-|)0x/.test(amount)) return new _bignumber["default"](amount.replace('0x', ''), 16);
      return new _bignumber["default"](amount.toString(10), 10);
    }
  }, {
    key: "isAddress",
    value: function isAddress() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!_utils["default"].isString(address)) return false; // Convert HEX to Base58

      if (address.length === 42) {
        try {
          return McashWeb.isAddress(_utils["default"].crypto.getBase58CheckAddress(_utils["default"].code.hexStr2byteArray(address) // it throws an error if the address starts with 0x
          ));
        } catch (err) {
          return false;
        }
      }

      try {
        return _utils["default"].crypto.isAddressValid(address);
      } catch (err) {
        return false;
      }
    }
  }, {
    key: "createAccount",
    value: function () {
      var _createAccount = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2() {
        var account;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                account = _utils["default"].accounts.generateAccount();
                return _context2.abrupt("return", account);

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function createAccount() {
        return _createAccount.apply(this, arguments);
      }

      return createAccount;
    }()
  }, {
    key: "address",
    get: function get() {
      return {
        fromHex: function fromHex(address) {
          if (!_utils["default"].isHex(address)) return address;
          return _utils["default"].crypto.getBase58CheckAddress(_utils["default"].code.hexStr2byteArray(address.replace(/^0x/, _address.ADDRESS_PREFIX)));
        },
        toHex: function toHex(address) {
          if (_utils["default"].isHex(address)) return address.toLowerCase().replace(/^0x/, _address.ADDRESS_PREFIX);
          return _utils["default"].code.byteArray2hexStr(_utils["default"].crypto.decodeBase58Address(address)).toLowerCase();
        },
        fromPrivateKey: function fromPrivateKey(privateKey) {
          try {
            return _utils["default"].crypto.pkToAddress(privateKey);
          } catch (_unused2) {
            return false;
          }
        }
      };
    }
  }]);
  return McashWeb;
}(_eventemitter["default"]);

exports["default"] = McashWeb;
(0, _defineProperty2["default"])(McashWeb, "providers", _providers["default"]);
(0, _defineProperty2["default"])(McashWeb, "BigNumber", _bignumber["default"]);
(0, _defineProperty2["default"])(McashWeb, "TransactionBuilder", _transactionBuilder["default"]);
(0, _defineProperty2["default"])(McashWeb, "Mcash", _mcash["default"]);
(0, _defineProperty2["default"])(McashWeb, "Contract", _contract["default"]);
(0, _defineProperty2["default"])(McashWeb, "Plugin", _plugin["default"]);
(0, _defineProperty2["default"])(McashWeb, "Event", _event["default"]);
(0, _defineProperty2["default"])(McashWeb, "version", _package.version);
(0, _defineProperty2["default"])(McashWeb, "utils", _utils["default"]);
;
//# sourceMappingURL=index.js.map