"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _index = _interopRequireDefault(require("index"));

var _utils = _interopRequireDefault(require("utils"));

var _method = _interopRequireDefault(require("./method"));

var Contract =
/*#__PURE__*/
function () {
  function Contract() {
    var mcashWeb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var abi = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var address = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    (0, _classCallCheck2["default"])(this, Contract);
    if (!mcashWeb || !mcashWeb instanceof _index["default"]) throw new Error('Expected instance of McashWeb');
    this.mcashWeb = mcashWeb;
    this.injectPromise = _utils["default"].promiseInjector(this);
    this.address = address;
    this.abi = abi;
    this.eventListener = false;
    this.bytecode = false;
    this.deployed = false;
    this.lastBlock = false;
    this.methods = {};
    this.methodInstances = {};
    this.props = [];
    if (this.mcashWeb.isAddress(address)) this.deployed = true;else this.address = false;
    this.loadAbi(abi);
  }

  (0, _createClass2["default"])(Contract, [{
    key: "_getEvents",
    value: function () {
      var _getEvents2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var _this = this;

        var options,
            events,
            _events$sort,
            _events$sort2,
            latestEvent,
            newEvents,
            _args = arguments;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
                _context.next = 3;
                return this.mcashWeb.event.getEventsByContractAddress(this.address, options);

              case 3:
                events = _context.sent;
                _events$sort = events.sort(function (a, b) {
                  return b.block - a.block;
                }), _events$sort2 = (0, _slicedToArray2["default"])(_events$sort, 1), latestEvent = _events$sort2[0];
                newEvents = events.filter(function (event, index) {
                  if (options.resourceNode && event.resourceNode && options.resourceNode.toLowerCase() !== event.resourceNode.toLowerCase()) {
                    return false;
                  }

                  var duplicate = events.slice(0, index).some(function (priorEvent) {
                    return JSON.stringify(priorEvent) == JSON.stringify(event);
                  });
                  if (duplicate) return false;
                  if (!_this.lastBlock) return true;
                  return event.block > _this.lastBlock;
                });
                if (latestEvent) this.lastBlock = latestEvent.block;
                return _context.abrupt("return", newEvents);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _getEvents() {
        return _getEvents2.apply(this, arguments);
      }

      return _getEvents;
    }()
  }, {
    key: "_startEventListener",
    value: function () {
      var _startEventListener2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2() {
        var _this2 = this;

        var options,
            callback,
            _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                options = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {};
                callback = _args2.length > 1 ? _args2[1] : undefined;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (this.eventListener) clearInterval(this.eventListener);

                if (this.mcashWeb.eventServer) {
                  _context2.next = 6;
                  break;
                }

                throw new Error('Event server is not configured');

              case 6:
                if (this.address) {
                  _context2.next = 8;
                  break;
                }

                throw new Error('Contract is not configured with an address');

              case 8:
                this.eventCallback = callback;
                _context2.next = 11;
                return this._getEvents(options);

              case 11:
                this.eventListener = setInterval(function () {
                  _this2._getEvents(options).then(function (newEvents) {
                    return newEvents.forEach(function (event) {
                      _this2.eventCallback && _this2.eventCallback(event);
                    });
                  })["catch"](function (err) {
                    console.error('Failed to get event list', err);
                  });
                }, 3000);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _startEventListener() {
        return _startEventListener2.apply(this, arguments);
      }

      return _startEventListener;
    }()
  }, {
    key: "_stopEventListener",
    value: function _stopEventListener() {
      if (!this.eventListener) return;
      clearInterval(this.eventListener);
      this.eventListener = false;
      this.eventCallback = false;
    }
  }, {
    key: "hasProperty",
    value: function hasProperty(property) {
      return this.hasOwnProperty(property) || this.__proto__.hasOwnProperty(property);
    }
  }, {
    key: "loadAbi",
    value: function loadAbi(abi) {
      var _this3 = this;

      this.abi = abi;
      this.methods = {};
      this.props.forEach(function (prop) {
        return delete _this3[prop];
      });
      abi.forEach(function (func) {
        // Don't build a method for constructor function. That's handled through contract create.
        if (!func.type || /constructor/i.test(func.type)) return;
        var method = new _method["default"](_this3, func);
        var methodCall = method.onMethod.bind(method);
        var name = method.name,
            functionSelector = method.functionSelector,
            signature = method.signature;
        _this3.methods[name] = methodCall;
        _this3.methods[functionSelector] = methodCall;
        _this3.methods[signature] = methodCall;
        _this3.methodInstances[name] = method;
        _this3.methodInstances[functionSelector] = method;
        _this3.methodInstances[signature] = method;

        if (!_this3.hasProperty(name)) {
          _this3[name] = methodCall;

          _this3.props.push(name);
        }

        if (!_this3.hasProperty(functionSelector)) {
          _this3[functionSelector] = methodCall;

          _this3.props.push(functionSelector);
        }

        if (!_this3.hasProperty(signature)) {
          _this3[signature] = methodCall;

          _this3.props.push(signature);
        }
      });
    }
  }, {
    key: "decodeInput",
    value: function decodeInput(data) {
      var methodName = data.substring(0, 8);
      var inputData = data.substring(8);
      if (!this.methodInstances[methodName]) throw new Error('Contract method ' + methodName + " not found");
      var methodInstance = this.methodInstances[methodName];
      return {
        name: methodInstance.name,
        params: this.methodInstances[methodName].decodeInput(inputData)
      };
    }
  }, {
    key: "new",
    value: function () {
      var _new2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee3(options) {
        var privateKey,
            callback,
            address,
            transaction,
            signedTransaction,
            contract,
            _args3 = arguments;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                privateKey = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : this.mcashWeb.defaultPrivateKey;
                callback = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : false;

                if (_utils["default"].isFunction(privateKey)) {
                  callback = privateKey;
                  privateKey = this.mcashWeb.defaultPrivateKey;
                }

                if (callback) {
                  _context3.next = 5;
                  break;
                }

                return _context3.abrupt("return", this.injectPromise(this["new"], options, privateKey));

              case 5:
                _context3.prev = 5;
                address = this.mcashWeb.address.fromPrivateKey(privateKey);
                _context3.next = 9;
                return this.mcashWeb.transactionBuilder.createSmartContract(options, address);

              case 9:
                transaction = _context3.sent;
                _context3.next = 12;
                return this.mcashWeb.mcash.sign(transaction, privateKey);

              case 12:
                signedTransaction = _context3.sent;
                _context3.next = 15;
                return this.mcashWeb.mcash.sendRawTransaction(signedTransaction);

              case 15:
                contract = _context3.sent;

                if (!contract.code) {
                  _context3.next = 18;
                  break;
                }

                return _context3.abrupt("return", callback({
                  error: contract.code,
                  message: this.mcashWeb.toUtf8(contract.message)
                }));

              case 18:
                return _context3.abrupt("return", this.at(signedTransaction.contract_address, callback));

              case 21:
                _context3.prev = 21;
                _context3.t0 = _context3["catch"](5);
                return _context3.abrupt("return", callback(_context3.t0));

              case 24:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[5, 21]]);
      }));

      function _new(_x) {
        return _new2.apply(this, arguments);
      }

      return _new;
    }()
  }, {
    key: "at",
    value: function () {
      var _at = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee4(contractAddress) {
        var callback,
            contract,
            _args4 = arguments;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                callback = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : false;

                if (callback) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt("return", this.injectPromise(this.at, contractAddress));

              case 3:
                _context4.prev = 3;
                _context4.next = 6;
                return this.mcashWeb.mcash.getContract(contractAddress);

              case 6:
                contract = _context4.sent;

                if (contract.contract_address) {
                  _context4.next = 9;
                  break;
                }

                return _context4.abrupt("return", callback('Unknown error: ' + JSON.stringify(contract, null, 2)));

              case 9:
                this.address = contract.contract_address;
                this.bytecode = contract.bytecode;
                this.deployed = true;
                this.loadAbi(contract.abi.entrys);
                return _context4.abrupt("return", callback(null, this));

              case 16:
                _context4.prev = 16;
                _context4.t0 = _context4["catch"](3);

                if (!_context4.t0.toString().includes('does not exist')) {
                  _context4.next = 20;
                  break;
                }

                return _context4.abrupt("return", callback('Contract has not been deployed on the network'));

              case 20:
                return _context4.abrupt("return", callback(_context4.t0));

              case 21:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[3, 16]]);
      }));

      function at(_x2) {
        return _at.apply(this, arguments);
      }

      return at;
    }()
  }, {
    key: "events",
    value: function events() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(options)) {
        callback = options;
        options = {};
      }

      if (!_utils["default"].isFunction(callback)) throw new Error('Callback function expected');
      var self = this;
      return {
        start: function start() {
          var startCallback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

          if (!startCallback) {
            self._startEventListener(options, callback);

            return this;
          }

          self._startEventListener(options, callback).then(function () {
            startCallback();
          })["catch"](function (err) {
            startCallback(err);
          });

          return this;
        },
        stop: function stop() {
          self._stopEventListener();
        }
      };
    }
  }]);
  return Contract;
}();

exports["default"] = Contract;
//# sourceMappingURL=index.js.map