"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _utils = _interopRequireDefault(require("utils"));

var _address = require("utils/address");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var getFunctionSelector = function getFunctionSelector(abi) {
  return abi.name + '(' + getParamTypes(abi.inputs || []).join(',') + ')';
};

var getParamTypes = function getParamTypes(params) {
  return params.map(function (_ref) {
    var type = _ref.type;
    return type;
  });
};

var decodeOutput = function decodeOutput(abi, output) {
  var names = abi.map(function (_ref2) {
    var name = _ref2.name;
    return name;
  }).filter(function (name) {
    return !!name;
  });
  var types = abi.map(function (_ref3) {
    var type = _ref3.type;
    return type;
  });
  return _utils["default"].abi.decodeParams(names, types, output);
};

var Method =
/*#__PURE__*/
function () {
  function Method(contract, abi) {
    (0, _classCallCheck2["default"])(this, Method);
    this.mcashWeb = contract.mcashWeb;
    this.contract = contract;
    this.abi = abi;
    this.name = abi.name || (abi.name = abi.type);
    this.inputs = abi.inputs || [];
    this.outputs = abi.outputs || [];
    this.functionSelector = getFunctionSelector(abi);
    this.signature = this.mcashWeb.sha3(this.functionSelector, false).slice(0, 8);
    this.injectPromise = _utils["default"].promiseInjector(this);
    this.defaultOptions = {
      feeLimit: 1000000000,
      callValue: 0,
      userFeePercentage: 100,
      shouldPollResponse: false // Only used for sign()

    };
  }

  (0, _createClass2["default"])(Method, [{
    key: "decodeInput",
    value: function decodeInput(data) {
      return decodeOutput(this.inputs, '0x' + data);
    }
  }, {
    key: "onMethod",
    value: function onMethod() {
      var _this = this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var types = getParamTypes(this.inputs);
      args.forEach(function (arg, index) {
        if (types[index] == 'address') args[index] = _this.mcashWeb.address.toHex(arg).replace(_address.ADDRESS_PREFIX_REGEX, '0x');

        if (types[index] == 'address[]') {
          args[index] = args[index].map(function (address) {
            return _this.mcashWeb.address.toHex(address).replace(_address.ADDRESS_PREFIX_REGEX, '0x');
          });
        }
      });
      return {
        call: function call() {
          for (var _len2 = arguments.length, methodArgs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            methodArgs[_key2] = arguments[_key2];
          }

          return _this._call.apply(_this, [types, args].concat(methodArgs));
        },
        send: function send() {
          for (var _len3 = arguments.length, methodArgs = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            methodArgs[_key3] = arguments[_key3];
          }

          return _this._send.apply(_this, [types, args].concat(methodArgs));
        },
        watch: function watch() {
          return _this._watch.apply(_this, arguments);
        }
      };
    }
  }, {
    key: "_call",
    value: function () {
      var _call2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(types, args) {
        var _this2 = this;

        var options,
            callback,
            stateMutability,
            parameters,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
                callback = _args.length > 3 && _args[3] !== undefined ? _args[3] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (callback) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return", this.injectPromise(this._call, types, args, options));

              case 5:
                if (!(types.length !== args.length)) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", callback('Invalid argument count provided'));

              case 7:
                if (this.contract.address) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt("return", callback('Smart contract is missing address'));

              case 9:
                if (this.contract.deployed) {
                  _context.next = 11;
                  break;
                }

                return _context.abrupt("return", callback('Calling smart contracts requires you to load the contract first'));

              case 11:
                stateMutability = this.abi.stateMutability;

                if (['pure', 'view'].includes(stateMutability.toLowerCase())) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt("return", callback("Methods with state mutability \"".concat(stateMutability, "\" must use send()")));

              case 14:
                options = _objectSpread({}, this.defaultOptions, {
                  from: this.mcashWeb.defaultAddress.hex
                }, options);
                parameters = args.map(function (value, index) {
                  return {
                    type: types[index],
                    value: value
                  };
                });
                this.mcashWeb.transactionBuilder.triggerSmartContract(this.contract.address, this.functionSelector, options, parameters, options.from ? this.mcashWeb.address.toHex(options.from) : false, function (err, transaction) {
                  if (err) return callback(err);
                  if (!_utils["default"].hasProperty(transaction, 'constant_result')) return callback('Failed to execute');

                  try {
                    var len = transaction.constant_result[0].length;

                    if (len === 0 || len % 64 === 8) {
                      var msg = 'The call has been reverted or has thrown an error.';

                      if (len !== 0) {
                        msg += ' Error message: ';
                        var msg2 = '';
                        var chunk = transaction.constant_result[0].substring(8);

                        for (var i = 0; i < len - 8; i += 64) {
                          msg2 += _this2.mcashWeb.toUtf8(chunk.substring(i, i + 64));
                        }

                        msg += msg2.replace(/(\u0000|\u000b|\f)+/g, ' ').replace(/ +/g, ' ').replace(/\s+$/g, '');
                      }

                      return callback(msg);
                    }

                    var output = decodeOutput(_this2.outputs, '0x' + transaction.constant_result[0]);
                    if (output.length === 1) output = output[0];
                    return callback(null, output);
                  } catch (ex) {
                    return callback(ex);
                  }
                });

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _call(_x, _x2) {
        return _call2.apply(this, arguments);
      }

      return _call;
    }()
  }, {
    key: "_send",
    value: function () {
      var _send2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee3(types, args) {
        var _this3 = this;

        var options,
            privateKey,
            callback,
            stateMutability,
            parameters,
            address,
            transaction,
            signedTransaction,
            broadcast,
            checkResult,
            _args3 = arguments;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                options = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : {};
                privateKey = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : this.mcashWeb.defaultPrivateKey;
                callback = _args3.length > 4 && _args3[4] !== undefined ? _args3[4] : false;

                if (_utils["default"].isFunction(privateKey)) {
                  callback = privateKey;
                  privateKey = this.mcashWeb.defaultPrivateKey;
                }

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (callback) {
                  _context3.next = 7;
                  break;
                }

                return _context3.abrupt("return", this.injectPromise(this._send, types, args, options, privateKey));

              case 7:
                if (!(types.length !== args.length)) {
                  _context3.next = 9;
                  break;
                }

                throw new Error('Invalid argument count provided');

              case 9:
                if (this.contract.address) {
                  _context3.next = 11;
                  break;
                }

                return _context3.abrupt("return", callback('Smart contract is missing address'));

              case 11:
                if (this.contract.deployed) {
                  _context3.next = 13;
                  break;
                }

                return _context3.abrupt("return", callback('Calling smart contracts requires you to load the contract first'));

              case 13:
                stateMutability = this.abi.stateMutability;

                if (!['pure', 'view'].includes(stateMutability.toLowerCase())) {
                  _context3.next = 16;
                  break;
                }

                return _context3.abrupt("return", callback("Methods with state mutability \"".concat(stateMutability, "\" must use call()")));

              case 16:
                // If a function isn't payable, dont provide a callValue.
                if (!['payable'].includes(stateMutability.toLowerCase())) options.callValue = 0;
                options = _objectSpread({}, this.defaultOptions, {
                  from: this.mcashWeb.defaultAddress.hex
                }, options);
                parameters = args.map(function (value, index) {
                  return {
                    type: types[index],
                    value: value
                  };
                });
                _context3.prev = 19;
                address = privateKey ? this.mcashWeb.address.fromPrivateKey(privateKey) : this.mcashWeb.defaultAddress.base58;
                _context3.next = 23;
                return this.mcashWeb.transactionBuilder.triggerSmartContract(this.contract.address, this.functionSelector, options, parameters, this.mcashWeb.address.toHex(address));

              case 23:
                transaction = _context3.sent;

                if (!(!transaction.result || !transaction.result.result)) {
                  _context3.next = 26;
                  break;
                }

                return _context3.abrupt("return", callback('Unknown error: ' + JSON.stringify(transaction, null, 2)));

              case 26:
                _context3.next = 28;
                return this.mcashWeb.mcash.sign(transaction.transaction, privateKey);

              case 28:
                signedTransaction = _context3.sent;

                if (signedTransaction.signature) {
                  _context3.next = 33;
                  break;
                }

                if (privateKey) {
                  _context3.next = 32;
                  break;
                }

                return _context3.abrupt("return", callback('Transaction was not signed properly'));

              case 32:
                return _context3.abrupt("return", callback('Invalid private key provided'));

              case 33:
                _context3.next = 35;
                return this.mcashWeb.mcash.sendRawTransaction(signedTransaction);

              case 35:
                broadcast = _context3.sent;

                if (!broadcast.code) {
                  _context3.next = 38;
                  break;
                }

                return _context3.abrupt("return", callback({
                  error: broadcast.code,
                  message: this.mcashWeb.toUtf8(broadcast.message)
                }));

              case 38:
                if (options.shouldPollResponse) {
                  _context3.next = 40;
                  break;
                }

                return _context3.abrupt("return", callback(null, signedTransaction.tx_id));

              case 40:
                checkResult =
                /*#__PURE__*/
                function () {
                  var _ref4 = (0, _asyncToGenerator2["default"])(
                  /*#__PURE__*/
                  _regenerator["default"].mark(function _callee2() {
                    var index,
                        output,
                        decoded,
                        _args2 = arguments;
                    return _regenerator["default"].wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            index = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : 0;

                            if (!(index == 20)) {
                              _context2.next = 3;
                              break;
                            }

                            return _context2.abrupt("return", callback({
                              error: 'Cannot find result in solidity node',
                              transaction: signedTransaction
                            }));

                          case 3:
                            _context2.next = 5;
                            return _this3.mcashWeb.mcash.getConfirmedTransactionInfo(signedTransaction.tx_id);

                          case 5:
                            output = _context2.sent;

                            if (Object.keys(output).length) {
                              _context2.next = 8;
                              break;
                            }

                            return _context2.abrupt("return", setTimeout(function () {
                              checkResult(index + 1);
                            }, 3000));

                          case 8:
                            if (!(output.result && output.result == 'FAILED')) {
                              _context2.next = 10;
                              break;
                            }

                            return _context2.abrupt("return", callback({
                              error: _this3.mcashWeb.toUtf8(output.res_message),
                              transaction: signedTransaction,
                              output: output
                            }));

                          case 10:
                            if (_utils["default"].hasProperty(output, 'contractResult')) {
                              _context2.next = 12;
                              break;
                            }

                            return _context2.abrupt("return", callback({
                              error: 'Failed to execute: ' + JSON.stringify(output, null, 2),
                              transaction: signedTransaction,
                              output: output
                            }));

                          case 12:
                            if (!options.rawResponse) {
                              _context2.next = 14;
                              break;
                            }

                            return _context2.abrupt("return", callback(null, output));

                          case 14:
                            decoded = decodeOutput(_this3.outputs, '0x' + output.contract_result[0]);
                            if (decoded.length === 1) decoded = decoded[0];
                            return _context2.abrupt("return", callback(null, decoded));

                          case 17:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  return function checkResult() {
                    return _ref4.apply(this, arguments);
                  };
                }();

                checkResult();
                _context3.next = 47;
                break;

              case 44:
                _context3.prev = 44;
                _context3.t0 = _context3["catch"](19);
                return _context3.abrupt("return", callback(_context3.t0));

              case 47:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[19, 44]]);
      }));

      function _send(_x3, _x4) {
        return _send2.apply(this, arguments);
      }

      return _send;
    }()
  }, {
    key: "_watch",
    value: function () {
      var _watch2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5() {
        var _this4 = this;

        var options,
            callback,
            listener,
            lastBlock,
            since,
            getEvents,
            bindListener,
            _args5 = arguments;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                options = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : {};
                callback = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (_utils["default"].isFunction(callback)) {
                  _context5.next = 5;
                  break;
                }

                throw new Error('Expected callback to be provided');

              case 5:
                if (this.contract.address) {
                  _context5.next = 7;
                  break;
                }

                return _context5.abrupt("return", callback('Smart contract is missing address'));

              case 7:
                if (!(!this.abi.type || !/event/i.test(this.abi.type))) {
                  _context5.next = 9;
                  break;
                }

                return _context5.abrupt("return", callback('Invalid method type for event watching'));

              case 9:
                if (this.mcashWeb.eventServer) {
                  _context5.next = 11;
                  break;
                }

                return _context5.abrupt("return", callback('No event server configured'));

              case 11:
                listener = false;
                lastBlock = false;
                since = Date.now() - 1000;

                getEvents =
                /*#__PURE__*/
                function () {
                  var _ref5 = (0, _asyncToGenerator2["default"])(
                  /*#__PURE__*/
                  _regenerator["default"].mark(function _callee4() {
                    var params, events, _events$sort, _events$sort2, latestEvent, newEvents;

                    return _regenerator["default"].wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            _context4.prev = 0;
                            params = {
                              since: since,
                              eventName: _this4.name,
                              sort: 'block_timestamp',
                              blockNumber: 'latest',
                              filters: options.filters
                            };

                            if (options.resourceNode) {
                              if (/full/i.test(options.resourceNode)) params.onlyUnconfirmed = true;else params.onlyConfirmed = true;
                            }

                            _context4.next = 5;
                            return _this4.mcashWeb.event.getEventsByContractAddress(_this4.contract.address, params);

                          case 5:
                            events = _context4.sent;
                            _events$sort = events.sort(function (a, b) {
                              return b.block - a.block;
                            }), _events$sort2 = (0, _slicedToArray2["default"])(_events$sort, 1), latestEvent = _events$sort2[0];
                            newEvents = events.filter(function (event, index) {
                              if (options.resourceNode && event.resourceNode && options.resourceNode.toLowerCase() !== event.resourceNode.toLowerCase()) {
                                return false;
                              }

                              var duplicate = events.slice(0, index).some(function (priorEvent) {
                                return JSON.stringify(priorEvent) == JSON.stringify(event);
                              });
                              if (duplicate) return false;
                              if (!lastBlock) return true;
                              return event.block > lastBlock;
                            });
                            if (latestEvent) lastBlock = latestEvent.block;
                            return _context4.abrupt("return", newEvents);

                          case 12:
                            _context4.prev = 12;
                            _context4.t0 = _context4["catch"](0);
                            return _context4.abrupt("return", Promise.reject(_context4.t0));

                          case 15:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee4, null, [[0, 12]]);
                  }));

                  return function getEvents() {
                    return _ref5.apply(this, arguments);
                  };
                }();

                bindListener = function bindListener() {
                  if (listener) clearInterval(listener);
                  listener = setInterval(function () {
                    getEvents().then(function (events) {
                      return events.forEach(function (event) {
                        callback(null, _utils["default"].parseEvent(event, _this4.abi));
                      });
                    })["catch"](function (err) {
                      return callback(err);
                    });
                  }, 3000);
                };

                _context5.next = 18;
                return getEvents();

              case 18:
                bindListener();
                return _context5.abrupt("return", {
                  start: bindListener(),
                  stop: function stop() {
                    if (!listener) return;
                    clearInterval(listener);
                    listener = false;
                  }
                });

              case 20:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _watch() {
        return _watch2.apply(this, arguments);
      }

      return _watch;
    }()
  }]);
  return Method;
}();

exports["default"] = Method;
//# sourceMappingURL=method.js.map