"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _index = _interopRequireDefault(require("index"));

var _utils = _interopRequireDefault(require("utils"));

var _ethersUtils = require("utils/ethersUtils");

var _address = require("utils/address");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var MCASH_MESSAGE_HEADER = '\x19MCASH Signed Message:\n32';
var ETH_MESSAGE_HEADER = '\x19Ethereum Signed Message:\n32';

var Mcash =
/*#__PURE__*/
function () {
  function Mcash() {
    var mcashWeb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    (0, _classCallCheck2["default"])(this, Mcash);
    if (!mcashWeb || !mcashWeb instanceof _index["default"]) throw new Error('Expected instance of McashWeb');
    this.mcashWeb = mcashWeb;
    this.injectPromise = _utils["default"].promiseInjector(this);
    this.cache = {
      contracts: {}
    };
  }

  (0, _createClass2["default"])(Mcash, [{
    key: "_parseToken",
    value: function _parseToken(token) {
      return _objectSpread({}, token, {
        name: this.mcashWeb.toUtf8(token.name),
        abbr: token.abbr && this.mcashWeb.toUtf8(token.abbr),
        description: token.description && this.mcashWeb.toUtf8(token.description),
        url: token.url && this.mcashWeb.toUtf8(token.url)
      });
    }
  }, {
    key: "getCurrentBlock",
    value: function getCurrentBlock() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.getCurrentBlock);
      this.mcashWeb.fullNode.request('wallet/getnowblock').then(function (block) {
        callback(null, block);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getConfirmedCurrentBlock",
    value: function getConfirmedCurrentBlock() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.getConfirmedCurrentBlock);
      this.mcashWeb.solidityNode.request('walletsolidity/getnowblock').then(function (block) {
        callback(null, block);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getBlock",
    value: function getBlock() {
      var block = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultBlock;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(block)) {
        callback = block;
        block = this.mcashWeb.defaultBlock;
      }

      if (!callback) return this.injectPromise(this.getBlock, block);
      if (block === false) return callback('No block identifier provided');
      if (block == 'earliest') block = 0;
      if (block == 'latest') return this.getCurrentBlock(callback);
      if (isNaN(block) && _utils["default"].isHex(block)) return this.getBlockByHash(block, callback);
      this.getBlockByNumber(block, callback);
    }
  }, {
    key: "getBlockByHash",
    value: function getBlockByHash(blockHash) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getBlockByHash, blockHash);
      this.mcashWeb.fullNode.request('wallet/getblockbyid', {
        value: blockHash
      }, 'post').then(function (block) {
        if (!Object.keys(block).length) return callback('Block not found');
        callback(null, block);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getBlockByNumber",
    value: function getBlockByNumber(blockID) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getBlockByNumber, blockID);
      if (!_utils["default"].isInteger(blockID) || blockID < 0) return callback('Invalid block number provided');
      this.mcashWeb.fullNode.request('wallet/getblockbynum', {
        num: blockID
      }, 'post').then(function (block) {
        if (!Object.keys(block).length) return callback('Block not found');
        callback(null, block);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getBlockTransactionCount",
    value: function getBlockTransactionCount() {
      var block = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultBlock;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(block)) {
        callback = block;
        block = this.mcashWeb.defaultBlock;
      }

      if (!callback) return this.injectPromise(this.getBlockTransactionCount, block);
      this.getBlock(block).then(function (_ref) {
        var _ref$transactions = _ref.transactions,
            transactions = _ref$transactions === void 0 ? [] : _ref$transactions;
        callback(null, transactions.length);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTransactionFromBlock",
    value: function getTransactionFromBlock() {
      var block = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultBlock;
      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (_utils["default"].isFunction(index)) {
        callback = index;
        index = 0;
      }

      if (_utils["default"].isFunction(block)) {
        callback = block;
        block = this.mcashWeb.defaultBlock;
      }

      if (!callback) return this.injectPromise(this.getTransactionFromBlock, block, index);
      if (!_utils["default"].isInteger(index) || index < 0) return callback('Invalid transaction index provided');
      this.getBlock(block).then(function (_ref2) {
        var _ref2$transactions = _ref2.transactions,
            transactions = _ref2$transactions === void 0 ? false : _ref2$transactions;
        if (!transactions || transactions.length < index) return callback('Transaction not found in block');
        callback(null, transactions[index]);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTransaction",
    value: function getTransaction(transactionID) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getTransaction, transactionID);
      this.mcashWeb.fullNode.request('wallet/gettransactionbyid', {
        value: transactionID
      }, 'post').then(function (transaction) {
        if (!Object.keys(transaction).length) return callback('Transaction not found');
        callback(null, transaction);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getConfirmedTransaction",
    value: function getConfirmedTransaction(transactionID) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getConfirmedTransaction, transactionID);
      this.mcashWeb.solidityNode.request('walletsolidity/gettransactionbyid', {
        value: transactionID
      }, 'post').then(function (transaction) {
        if (!Object.keys(transaction).length) return callback('Transaction not found');
        callback(null, transaction);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTransactionInfo",
    value: function getTransactionInfo(transactionID) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getTransactionInfo, transactionID);
      this.mcashWeb.solidityNode.request('wallet/gettransactioninfobyid', {
        value: transactionID
      }, 'post').then(function (transaction) {
        callback(null, transaction);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getConfirmedTransactionInfo",
    value: function getConfirmedTransactionInfo(transactionID) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getConfirmedTransactionInfo, transactionID);
      this.mcashWeb.solidityNode.request('walletsolidity/gettransactioninfobyid', {
        value: transactionID
      }, 'post').then(function (transaction) {
        callback(null, transaction);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTransactionsToAddress",
    value: function getTransactionsToAddress() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30;
      var offset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var callback = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

      if (_utils["default"].isFunction(offset)) {
        callback = offset;
        offset = 0;
      }

      if (_utils["default"].isFunction(limit)) {
        callback = limit;
        limit = 30;
      }

      if (!callback) return this.injectPromise(this.getTransactionsToAddress, address, limit, offset);
      address = this.mcashWeb.address.toHex(address);
      return this.getTransactionsRelated(address, 'to', limit, offset, callback);
    }
  }, {
    key: "getTransactionsFromAddress",
    value: function getTransactionsFromAddress() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30;
      var offset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var callback = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

      if (_utils["default"].isFunction(offset)) {
        callback = offset;
        offset = 0;
      }

      if (_utils["default"].isFunction(limit)) {
        callback = limit;
        limit = 30;
      }

      if (!callback) return this.injectPromise(this.getTransactionsFromAddress, address, limit, offset);
      address = this.mcashWeb.address.toHex(address);
      return this.getTransactionsRelated(address, 'from', limit, offset, callback);
    }
  }, {
    key: "getTransactionsRelated",
    value: function () {
      var _getTransactionsRelated = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var address,
            direction,
            limit,
            offset,
            callback,
            _ref3,
            _ref4,
            from,
            to,
            _args = arguments;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                address = _args.length > 0 && _args[0] !== undefined ? _args[0] : this.mcashWeb.defaultAddress.hex;
                direction = _args.length > 1 && _args[1] !== undefined ? _args[1] : 'all';
                limit = _args.length > 2 && _args[2] !== undefined ? _args[2] : 30;
                offset = _args.length > 3 && _args[3] !== undefined ? _args[3] : 0;
                callback = _args.length > 4 && _args[4] !== undefined ? _args[4] : false;

                if (_utils["default"].isFunction(offset)) {
                  callback = offset;
                  offset = 0;
                }

                if (_utils["default"].isFunction(limit)) {
                  callback = limit;
                  limit = 30;
                }

                if (_utils["default"].isFunction(direction)) {
                  callback = direction;
                  direction = 'all';
                }

                if (_utils["default"].isFunction(address)) {
                  callback = address;
                  address = this.mcashWeb.defaultAddress.hex;
                }

                if (callback) {
                  _context.next = 11;
                  break;
                }

                return _context.abrupt("return", this.injectPromise(this.getTransactionsRelated, address, direction, limit, offset));

              case 11:
                if (['to', 'from', 'all'].includes(direction)) {
                  _context.next = 13;
                  break;
                }

                return _context.abrupt("return", callback('Invalid direction provided: Expected "to", "from" or "all"'));

              case 13:
                if (!(direction == 'all')) {
                  _context.next = 27;
                  break;
                }

                _context.prev = 14;
                _context.next = 17;
                return Promise.all([this.getTransactionsRelated(address, 'from', limit, offset), this.getTransactionsRelated(address, 'to', limit, offset)]);

              case 17:
                _ref3 = _context.sent;
                _ref4 = (0, _slicedToArray2["default"])(_ref3, 2);
                from = _ref4[0];
                to = _ref4[1];
                return _context.abrupt("return", callback(null, [].concat((0, _toConsumableArray2["default"])(from.map(function (tx) {
                  return tx.direction = 'from', tx;
                })), (0, _toConsumableArray2["default"])(to.map(function (tx) {
                  return tx.direction = 'to', tx;
                }))).sort(function (a, b) {
                  return b.raw_data.timestamp - a.raw_data.timestamp;
                })));

              case 24:
                _context.prev = 24;
                _context.t0 = _context["catch"](14);
                return _context.abrupt("return", callback(_context.t0));

              case 27:
                if (this.mcashWeb.isAddress(address)) {
                  _context.next = 29;
                  break;
                }

                return _context.abrupt("return", callback('Invalid address provided'));

              case 29:
                if (!(!_utils["default"].isInteger(limit) || limit < 0 || offset && limit < 1)) {
                  _context.next = 31;
                  break;
                }

                return _context.abrupt("return", callback('Invalid limit provided'));

              case 31:
                if (!(!_utils["default"].isInteger(offset) || offset < 0)) {
                  _context.next = 33;
                  break;
                }

                return _context.abrupt("return", callback('Invalid offset provided'));

              case 33:
                address = this.mcashWeb.address.toHex(address);
                this.mcashWeb.solidityNode.request("walletextension/gettransactions".concat(direction, "this"), {
                  account: {
                    address: address
                  },
                  offset: offset,
                  limit: limit
                }, 'post').then(function (_ref5) {
                  var transaction = _ref5.transaction;
                  callback(null, transaction);
                })["catch"](function (err) {
                  return callback(err);
                });

              case 35:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[14, 24]]);
      }));

      function getTransactionsRelated() {
        return _getTransactionsRelated.apply(this, arguments);
      }

      return getTransactionsRelated;
    }()
  }, {
    key: "getAccount",
    value: function getAccount() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(address)) {
        callback = address;
        address = this.mcashWeb.defaultAddress.hex;
      }

      if (!callback) return this.injectPromise(this.getAccount, address);
      if (!this.mcashWeb.isAddress(address)) return callback('Invalid address provided');
      address = this.mcashWeb.address.toHex(address); // this.tronWeb.solidityNode.request('walletsolidity/getaccount', {
      //     address
      // }, 'post').then(account => {
      //     callback(null, account);
      // }).catch(err => callback(err));

      this.mcashWeb.fullNode.request('wallet/getaccount', {
        address: address
      }, 'post').then(function (account) {
        callback(null, account);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getBalance",
    value: function getBalance() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(address)) {
        callback = address;
        address = this.mcashWeb.defaultAddress.hex;
      }

      if (!callback) return this.injectPromise(this.getBalance, address);
      this.getAccount(address).then(function (_ref6) {
        var _ref6$balance = _ref6.balance,
            balance = _ref6$balance === void 0 ? 0 : _ref6$balance;
        callback(null, balance);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getUnconfirmedAccount",
    value: function getUnconfirmedAccount() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(address)) {
        callback = address;
        address = this.mcashWeb.defaultAddress.hex;
      }

      if (!callback) return this.injectPromise(this.getUnconfirmedAccount, address);
      if (!this.mcashWeb.isAddress(address)) return callback('Invalid address provided');
      address = this.mcashWeb.address.toHex(address);
      this.mcashWeb.fullNode.request('wallet/getaccount', {
        address: address
      }, 'post').then(function (account) {
        callback(null, account);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getUnconfirmedBalance",
    value: function getUnconfirmedBalance() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(address)) {
        callback = address;
        address = this.mcashWeb.defaultAddress.hex;
      }

      if (!callback) return this.injectPromise(this.getUnconfirmedBalance, address);
      this.getUnconfirmedAccount(address).then(function (_ref7) {
        var _ref7$balance = _ref7.balance,
            balance = _ref7$balance === void 0 ? 0 : _ref7$balance;
        callback(null, balance);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getBandwidth",
    value: function getBandwidth() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(address)) {
        callback = address;
        address = this.mcashWeb.defaultAddress.hex;
      }

      if (!callback) return this.injectPromise(this.getBandwidth, address);
      if (!this.mcashWeb.isAddress(address)) return callback('Invalid address provided');
      address = this.mcashWeb.address.toHex(address);
      this.mcashWeb.fullNode.request('wallet/getaccountnet', {
        address: address
      }, 'post').then(function (_ref8) {
        var _ref8$free_bandwidth_ = _ref8.free_bandwidth_used,
            free_bandwidth_used = _ref8$free_bandwidth_ === void 0 ? 0 : _ref8$free_bandwidth_,
            _ref8$free_bandwidth_2 = _ref8.free_bandwidth_limit,
            free_bandwidth_limit = _ref8$free_bandwidth_2 === void 0 ? 0 : _ref8$free_bandwidth_2,
            _ref8$bandwidth_used = _ref8.bandwidth_used,
            bandwidth_used = _ref8$bandwidth_used === void 0 ? 0 : _ref8$bandwidth_used,
            _ref8$bandwidth_limit = _ref8.bandwidth_limit,
            bandwidth_limit = _ref8$bandwidth_limit === void 0 ? 0 : _ref8$bandwidth_limit;
        callback(null, free_bandwidth_limit - free_bandwidth_used + (bandwidth_limit - bandwidth_used));
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTokensIssuedByAddress",
    value: function getTokensIssuedByAddress() {
      var _this = this;

      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (_utils["default"].isFunction(address)) {
        callback = address;
        address = this.mcashWeb.defaultAddress.hex;
      }

      if (!callback) return this.injectPromise(this.getTokensIssuedByAddress, address);
      if (!this.mcashWeb.isAddress(address)) return callback('Invalid address provided');
      address = this.mcashWeb.address.toHex(address);
      this.mcashWeb.fullNode.request('wallet/getassetissuebyaccount', {
        address: address
      }, 'post').then(function (_ref9) {
        var _ref9$asset_issue = _ref9.asset_issue,
            asset_issue = _ref9$asset_issue === void 0 ? false : _ref9$asset_issue;
        if (!asset_issue) return callback(null, {});
        var tokens = asset_issue.map(function (token) {
          return _this._parseToken(token);
        }).reduce(function (tokens, token) {
          return tokens[token.name] = token, tokens;
        }, {});
        callback(null, tokens);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTokenFromId",
    value: function getTokenFromId() {
      var _this2 = this;

      var tokenId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getTokenFromId, tokenId);
      if (_utils["default"].isString(tokenId)) tokenId = parseInt(tokenId);
      if (!_utils["default"].isInteger(tokenId)) return callback('Invalid token ID provided');
      this.mcashWeb.fullNode.request('wallet/getassetissuebyid', {
        value: tokenId
      }, 'post').then(function (token) {
        if (!token.name) return callback('Token does not exist');
        callback(null, _this2._parseToken(token));
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "listNodes",
    value: function listNodes() {
      var _this3 = this;

      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.listNodes);
      this.mcashWeb.fullNode.request('wallet/listnodes').then(function (_ref10) {
        var _ref10$nodes = _ref10.nodes,
            nodes = _ref10$nodes === void 0 ? [] : _ref10$nodes;
        callback(null, nodes.map(function (_ref11) {
          var _ref11$address = _ref11.address,
              host = _ref11$address.host,
              port = _ref11$address.port;
          return "".concat(_this3.mcashWeb.toUtf8(host), ":").concat(port);
        }));
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getBlockRange",
    value: function getBlockRange() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var end = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30;
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (_utils["default"].isFunction(end)) {
        callback = end;
        end = 30;
      }

      if (_utils["default"].isFunction(start)) {
        callback = start;
        start = 0;
      }

      if (!callback) return this.injectPromise(this.getBlockRange, start, end);
      if (!_utils["default"].isInteger(start) || start < 0) return callback('Invalid start of range provided');
      if (!_utils["default"].isInteger(end) || end <= start) return callback('Invalid end of range provided');
      this.mcashWeb.fullNode.request('wallet/getblockbylimitnext', {
        start_num: parseInt(start),
        end_num: parseInt(end) + 1
      }, 'post').then(function (_ref12) {
        var _ref12$block = _ref12.block,
            block = _ref12$block === void 0 ? [] : _ref12$block;
        callback(null, block);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "listSuperRepresentatives",
    value: function listSuperRepresentatives() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.listSuperRepresentatives);
      this.mcashWeb.fullNode.request('wallet/listwitnesses').then(function (_ref13) {
        var _ref13$witnesses = _ref13.witnesses,
            witnesses = _ref13$witnesses === void 0 ? [] : _ref13$witnesses;
        callback(null, witnesses);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "listTokens",
    value: function listTokens() {
      var _this4 = this;

      var limit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (_utils["default"].isFunction(offset)) {
        callback = offset;
        offset = 0;
      }

      if (_utils["default"].isFunction(limit)) {
        callback = limit;
        limit = 0;
      }

      if (!callback) return this.injectPromise(this.listTokens, limit, offset);
      if (!_utils["default"].isInteger(limit) || limit < 0 || offset && limit < 1) return callback('Invalid limit provided');
      if (!_utils["default"].isInteger(offset) || offset < 0) return callback('Invalid offset provided');

      if (!limit) {
        return this.mcashWeb.fullNode.request('wallet/getassetissuelist').then(function (_ref14) {
          var _ref14$assetIssue = _ref14.assetIssue,
              assetIssue = _ref14$assetIssue === void 0 ? [] : _ref14$assetIssue;
          callback(null, assetIssue.map(function (token) {
            return _this4._parseToken(token);
          }));
        })["catch"](function (err) {
          return callback(err);
        });
      }

      this.mcashWeb.fullNode.request('wallet/getpaginatedassetissuelist', {
        offset: parseInt(offset),
        limit: parseInt(limit)
      }, 'post').then(function (_ref15) {
        var _ref15$assetIssue = _ref15.assetIssue,
            assetIssue = _ref15$assetIssue === void 0 ? [] : _ref15$assetIssue;
        callback(null, assetIssue.map(function (token) {
          return _this4._parseToken(token);
        }));
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "timeUntilNextVoteCycle",
    value: function timeUntilNextVoteCycle() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.timeUntilNextVoteCycle);
      this.mcashWeb.fullNode.request('wallet/getnextmaintenancetime').then(function (_ref16) {
        var _ref16$num = _ref16.num,
            num = _ref16$num === void 0 ? -1 : _ref16$num;
        if (num == -1) return callback('Failed to get time until next vote cycle');
        callback(null, Math.floor(num / 1000));
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getContract",
    value: function getContract(contractAddress) {
      var _this5 = this;

      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getContract, contractAddress);
      if (!this.mcashWeb.isAddress(contractAddress)) return callback('Invalid contract address provided');

      if (this.cache.contracts[contractAddress]) {
        callback(null, this.cache.contracts[contractAddress]);
        return;
      }

      contractAddress = this.mcashWeb.address.toHex(contractAddress);
      this.mcashWeb.fullNode.request('wallet/getcontract', {
        value: contractAddress
      }).then(function (contract) {
        if (contract.Error) return callback('Contract does not exist');
        _this5.cache.contracts[contractAddress] = contract;
        callback(null, contract);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "verifyMessage",
    value: function () {
      var _verifyMessage = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2() {
        var message,
            signature,
            address,
            useTronHeader,
            callback,
            _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                message = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : false;
                signature = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : false;
                address = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : this.mcashWeb.defaultAddress.base58;
                useTronHeader = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : true;
                callback = _args2.length > 4 && _args2[4] !== undefined ? _args2[4] : false;

                if (_utils["default"].isFunction(address)) {
                  callback = address;
                  address = this.mcashWeb.defaultAddress.base58;
                  useTronHeader = true;
                }

                if (_utils["default"].isFunction(useTronHeader)) {
                  callback = useTronHeader;
                  useTronHeader = true;
                }

                if (callback) {
                  _context2.next = 9;
                  break;
                }

                return _context2.abrupt("return", this.injectPromise(this.verifyMessage, message, signature, address, useTronHeader));

              case 9:
                if (_utils["default"].isHex(message)) {
                  _context2.next = 11;
                  break;
                }

                return _context2.abrupt("return", callback('Expected hex message input'));

              case 11:
                if (!Mcash.verifySignature(message, address, signature, useTronHeader)) {
                  _context2.next = 13;
                  break;
                }

                return _context2.abrupt("return", callback(null, true));

              case 13:
                callback('Signature does not match');

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function verifyMessage() {
        return _verifyMessage.apply(this, arguments);
      }

      return verifyMessage;
    }()
  }, {
    key: "sign",
    value: function () {
      var _sign = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee3() {
        var transaction,
            privateKey,
            useTronHeader,
            multisig,
            callback,
            signatureHex,
            address,
            _args3 = arguments;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                transaction = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : false;
                privateKey = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : this.mcashWeb.defaultPrivateKey;
                useTronHeader = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : true;
                multisig = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : false;
                callback = _args3.length > 4 && _args3[4] !== undefined ? _args3[4] : false;

                if (_utils["default"].isFunction(multisig)) {
                  callback = multisig;
                  multisig = false;
                }

                if (_utils["default"].isFunction(useTronHeader)) {
                  callback = useTronHeader;
                  useTronHeader = true;
                  multisig = false;
                }

                if (_utils["default"].isFunction(privateKey)) {
                  callback = privateKey;
                  privateKey = this.mcashWeb.defaultPrivateKey;
                  useTronHeader = true;
                  multisig = false;
                }

                if (callback) {
                  _context3.next = 10;
                  break;
                }

                return _context3.abrupt("return", this.injectPromise(this.sign, transaction, privateKey, useTronHeader, multisig));

              case 10:
                if (!_utils["default"].isString(transaction)) {
                  _context3.next = 21;
                  break;
                }

                if (_utils["default"].isHex(transaction)) {
                  _context3.next = 13;
                  break;
                }

                return _context3.abrupt("return", callback('Expected hex message input'));

              case 13:
                _context3.prev = 13;
                signatureHex = Mcash.signString(transaction, privateKey, useTronHeader);
                return _context3.abrupt("return", callback(null, signatureHex));

              case 18:
                _context3.prev = 18;
                _context3.t0 = _context3["catch"](13);
                callback(_context3.t0);

              case 21:
                if (_utils["default"].isObject(transaction)) {
                  _context3.next = 23;
                  break;
                }

                return _context3.abrupt("return", callback('Invalid transaction provided'));

              case 23:
                if (!(!multisig && transaction.signature)) {
                  _context3.next = 25;
                  break;
                }

                return _context3.abrupt("return", callback('Transaction is already signed'));

              case 25:
                _context3.prev = 25;

                if (multisig) {
                  _context3.next = 30;
                  break;
                }

                address = this.mcashWeb.address.toHex(this.mcashWeb.address.fromPrivateKey(privateKey)).toLowerCase();

                if (!(address !== transaction.raw_data.contract[0].parameter.value.owner_address.toLowerCase())) {
                  _context3.next = 30;
                  break;
                }

                return _context3.abrupt("return", callback('Private key does not match address in transaction'));

              case 30:
                return _context3.abrupt("return", callback(null, _utils["default"].crypto.signTransaction(privateKey, transaction)));

              case 33:
                _context3.prev = 33;
                _context3.t1 = _context3["catch"](25);
                callback(_context3.t1);

              case 36:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[13, 18], [25, 33]]);
      }));

      function sign() {
        return _sign.apply(this, arguments);
      }

      return sign;
    }()
  }, {
    key: "multiSign",
    value: function () {
      var _multiSign = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee4() {
        var transaction,
            privateKey,
            permissionId,
            callback,
            address,
            signWeight,
            foundKey,
            _args4 = arguments;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                transaction = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : false;
                privateKey = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : this.mcashWeb.defaultPrivateKey;
                permissionId = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : false;
                callback = _args4.length > 3 && _args4[3] !== undefined ? _args4[3] : false;

                if (_utils["default"].isFunction(permissionId)) {
                  callback = permissionId;
                  permissionId = 0;
                }

                if (_utils["default"].isFunction(privateKey)) {
                  callback = privateKey;
                  privateKey = this.mcashWeb.defaultPrivateKey;
                  permissionId = 0;
                }

                if (callback) {
                  _context4.next = 8;
                  break;
                }

                return _context4.abrupt("return", this.injectPromise(this.multiSign, transaction, privateKey, permissionId));

              case 8:
                if (!(!_utils["default"].isObject(transaction) || !transaction.raw_data || !transaction.raw_data.contract)) {
                  _context4.next = 10;
                  break;
                }

                return _context4.abrupt("return", callback('Invalid transaction provided'));

              case 10:
                // set permission id
                transaction.raw_data.contract[0].Permission_id = permissionId; // check if private key insides permission list

                address = this.mcashWeb.address.toHex(this.mcashWeb.address.fromPrivateKey(privateKey)).toLowerCase();
                _context4.next = 14;
                return this.getSignWeight(transaction, permissionId);

              case 14:
                signWeight = _context4.sent;

                if (!(signWeight.result.code === 'PERMISSION_ERROR')) {
                  _context4.next = 17;
                  break;
                }

                return _context4.abrupt("return", callback(signWeight.result.message));

              case 17:
                foundKey = false;
                signWeight.permission.keys.map(function (key) {
                  if (key.address === address) foundKey = true;
                });

                if (foundKey) {
                  _context4.next = 21;
                  break;
                }

                return _context4.abrupt("return", callback(privateKey + ' has no permission to sign'));

              case 21:
                if (!(signWeight.approved_list && signWeight.approved_list.indexOf(address) != -1)) {
                  _context4.next = 23;
                  break;
                }

                return _context4.abrupt("return", callback(privateKey + ' already sign transaction'));

              case 23:
                if (!(signWeight.transaction && signWeight.transaction.transaction)) {
                  _context4.next = 28;
                  break;
                }

                transaction = signWeight.transaction.transaction;
                transaction.raw_data.contract[0].Permission_id = permissionId;
                _context4.next = 29;
                break;

              case 28:
                return _context4.abrupt("return", callback('Invalid transaction provided'));

              case 29:
                _context4.prev = 29;
                return _context4.abrupt("return", callback(null, _utils["default"].crypto.signTransaction(privateKey, transaction)));

              case 33:
                _context4.prev = 33;
                _context4.t0 = _context4["catch"](29);
                callback(_context4.t0);

              case 36:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[29, 33]]);
      }));

      function multiSign() {
        return _multiSign.apply(this, arguments);
      }

      return multiSign;
    }()
  }, {
    key: "getApprovedList",
    value: function () {
      var _getApprovedList = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5(transaction) {
        var callback,
            _args5 = arguments;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                callback = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : false;

                if (callback) {
                  _context5.next = 3;
                  break;
                }

                return _context5.abrupt("return", this.injectPromise(this.getApprovedList, transaction));

              case 3:
                if (_utils["default"].isObject(transaction)) {
                  _context5.next = 5;
                  break;
                }

                return _context5.abrupt("return", callback('Invalid transaction provided'));

              case 5:
                this.mcashWeb.fullNode.request('wallet/getapprovedlist', transaction, 'post').then(function (result) {
                  callback(null, result);
                })["catch"](function (err) {
                  return callback(err);
                });

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getApprovedList(_x) {
        return _getApprovedList.apply(this, arguments);
      }

      return getApprovedList;
    }()
  }, {
    key: "getSignWeight",
    value: function () {
      var _getSignWeight = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee6(transaction, permissionId) {
        var callback,
            _args6 = arguments;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                callback = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : false;

                if (_utils["default"].isFunction(permissionId)) {
                  callback = permissionId;
                  permissionId = undefined;
                }

                if (callback) {
                  _context6.next = 4;
                  break;
                }

                return _context6.abrupt("return", this.injectPromise(this.getSignWeight, transaction, permissionId));

              case 4:
                if (!(!_utils["default"].isObject(transaction) || !transaction.raw_data || !transaction.raw_data.contract)) {
                  _context6.next = 6;
                  break;
                }

                return _context6.abrupt("return", callback('Invalid transaction provided'));

              case 6:
                if (_utils["default"].isInteger(permissionId)) {
                  transaction.raw_data.contract[0].Permission_id = parseInt(permissionId);
                } else if (typeof transaction.raw_data.contract[0].Permission_id !== 'number') {
                  transaction.raw_data.contract[0].Permission_id = 0;
                }

                if (_utils["default"].isObject(transaction)) {
                  _context6.next = 9;
                  break;
                }

                return _context6.abrupt("return", callback('Invalid transaction provided'));

              case 9:
                this.mcashWeb.fullNode.request('wallet/getsignweight', transaction, 'post').then(function (result) {
                  callback(null, result);
                })["catch"](function (err) {
                  return callback(err);
                });

              case 10:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getSignWeight(_x2, _x3) {
        return _getSignWeight.apply(this, arguments);
      }

      return getSignWeight;
    }()
  }, {
    key: "sendRawTransaction",
    value: function sendRawTransaction() {
      var signedTransaction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (_utils["default"].isFunction(options)) {
        callback = options;
        options = {};
      }

      if (!callback) return this.injectPromise(this.sendRawTransaction, signedTransaction, options);
      if (!_utils["default"].isObject(signedTransaction)) return callback('Invalid transaction provided');
      if (!_utils["default"].isObject(options)) return callback('Invalid options provided');
      if (!signedTransaction.signature || !_utils["default"].isArray(signedTransaction.signature)) return callback('Transaction is not signed');
      this.mcashWeb.fullNode.request('wallet/broadcasttransaction', signedTransaction, 'post').then(function (result) {
        if (result.result) result.transaction = signedTransaction;
        callback(null, result);
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "sendTransaction",
    value: function () {
      var _sendTransaction = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee7() {
        var to,
            amount,
            options,
            callback,
            address,
            transaction,
            signedTransaction,
            result,
            _args7 = arguments;
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                to = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : false;
                amount = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : false;
                options = _args7.length > 2 && _args7[2] !== undefined ? _args7[2] : {};
                callback = _args7.length > 3 && _args7[3] !== undefined ? _args7[3] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context7.next = 8;
                  break;
                }

                return _context7.abrupt("return", this.injectPromise(this.sendTransaction, to, amount, options));

              case 8:
                if (this.mcashWeb.isAddress(to)) {
                  _context7.next = 10;
                  break;
                }

                return _context7.abrupt("return", callback('Invalid recipient provided'));

              case 10:
                if (!(!_utils["default"].isInteger(amount) || amount <= 0)) {
                  _context7.next = 12;
                  break;
                }

                return _context7.abrupt("return", callback('Invalid amount provided'));

              case 12:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context7.next = 15;
                  break;
                }

                return _context7.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 15:
                _context7.prev = 15;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context7.next = 19;
                return this.mcashWeb.transactionBuilder.sendMcash(to, amount, address);

              case 19:
                transaction = _context7.sent;
                _context7.next = 22;
                return this.sign(transaction, options.privateKey || undefined);

              case 22:
                signedTransaction = _context7.sent;
                _context7.next = 25;
                return this.sendRawTransaction(signedTransaction);

              case 25:
                result = _context7.sent;
                return _context7.abrupt("return", callback(null, result));

              case 29:
                _context7.prev = 29;
                _context7.t0 = _context7["catch"](15);
                return _context7.abrupt("return", callback(_context7.t0));

              case 32:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[15, 29]]);
      }));

      function sendTransaction() {
        return _sendTransaction.apply(this, arguments);
      }

      return sendTransaction;
    }()
  }, {
    key: "sendToken",
    value: function () {
      var _sendToken = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee8() {
        var to,
            amount,
            tokenId,
            options,
            callback,
            address,
            transaction,
            signedTransaction,
            result,
            _args8 = arguments;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                to = _args8.length > 0 && _args8[0] !== undefined ? _args8[0] : false;
                amount = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : false;
                tokenId = _args8.length > 2 && _args8[2] !== undefined ? _args8[2] : false;
                options = _args8.length > 3 && _args8[3] !== undefined ? _args8[3] : {};
                callback = _args8.length > 4 && _args8[4] !== undefined ? _args8[4] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context8.next = 9;
                  break;
                }

                return _context8.abrupt("return", this.injectPromise(this.sendToken, to, amount, tokenId, options));

              case 9:
                if (this.mcashWeb.isAddress(to)) {
                  _context8.next = 11;
                  break;
                }

                return _context8.abrupt("return", callback('Invalid recipient provided'));

              case 11:
                if (!(!_utils["default"].isInteger(amount) || amount <= 0)) {
                  _context8.next = 13;
                  break;
                }

                return _context8.abrupt("return", callback('Invalid amount provided'));

              case 13:
                if (_utils["default"].isString(tokenId)) tokenId = parseInt(tokenId);

                if (_utils["default"].isInteger(tokenId)) {
                  _context8.next = 16;
                  break;
                }

                return _context8.abrupt("return", callback('Invalid token ID provided'));

              case 16:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context8.next = 19;
                  break;
                }

                return _context8.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 19:
                _context8.prev = 19;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context8.next = 23;
                return this.mcashWeb.transactionBuilder.sendToken(to, amount, tokenId, address);

              case 23:
                transaction = _context8.sent;
                _context8.next = 26;
                return this.sign(transaction, options.privateKey || undefined);

              case 26:
                signedTransaction = _context8.sent;
                _context8.next = 29;
                return this.sendRawTransaction(signedTransaction);

              case 29:
                result = _context8.sent;
                return _context8.abrupt("return", callback(null, result));

              case 33:
                _context8.prev = 33;
                _context8.t0 = _context8["catch"](19);
                return _context8.abrupt("return", callback(_context8.t0));

              case 36:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this, [[19, 33]]);
      }));

      function sendToken() {
        return _sendToken.apply(this, arguments);
      }

      return sendToken;
    }()
    /**
     * Freezes an amount of MCASH.
     *
     * @param amount - is the number of frozen MCASH
     * @param duration - is the duration in days to be frozen
     * @param resource - is the type, must be either "ENERGY" or "BANDWIDTH"
     * @param options
     * @param callback
     */

  }, {
    key: "freezeBalance",
    value: function () {
      var _freezeBalance = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee9() {
        var amount,
            duration,
            resource,
            options,
            receiverAddress,
            callback,
            address,
            _freezeBalance2,
            signedTransaction,
            result,
            _args9 = arguments;

        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                amount = _args9.length > 0 && _args9[0] !== undefined ? _args9[0] : 0;
                duration = _args9.length > 1 && _args9[1] !== undefined ? _args9[1] : 3;
                resource = _args9.length > 2 && _args9[2] !== undefined ? _args9[2] : "BANDWIDTH";
                options = _args9.length > 3 && _args9[3] !== undefined ? _args9[3] : {};
                receiverAddress = _args9.length > 4 && _args9[4] !== undefined ? _args9[4] : undefined;
                callback = _args9.length > 5 && _args9[5] !== undefined ? _args9[5] : false;

                if (_utils["default"].isFunction(receiverAddress)) {
                  callback = receiverAddress;
                  receiverAddress = undefined;
                }

                if (_utils["default"].isFunction(duration)) {
                  callback = duration;
                  duration = 3;
                }

                if (_utils["default"].isFunction(resource)) {
                  callback = resource;
                  resource = "BANDWIDTH";
                }

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context9.next = 13;
                  break;
                }

                return _context9.abrupt("return", this.injectPromise(this.freezeBalance, amount, duration, resource, options, receiverAddress));

              case 13:
                if (['BANDWIDTH', 'ENERGY'].includes(resource)) {
                  _context9.next = 15;
                  break;
                }

                return _context9.abrupt("return", callback('Invalid resource provided: Expected "BANDWIDTH" or "ENERGY"'));

              case 15:
                if (!(!_utils["default"].isInteger(amount) || amount <= 0)) {
                  _context9.next = 17;
                  break;
                }

                return _context9.abrupt("return", callback('Invalid amount provided'));

              case 17:
                if (!(!_utils["default"].isInteger(duration) || duration < 3)) {
                  _context9.next = 19;
                  break;
                }

                return _context9.abrupt("return", callback('Invalid duration provided, minimum of 3 days'));

              case 19:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context9.next = 22;
                  break;
                }

                return _context9.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 22:
                _context9.prev = 22;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context9.next = 26;
                return this.mcashWeb.transactionBuilder.freezeBalance(amount, duration, resource, address, receiverAddress);

              case 26:
                _freezeBalance2 = _context9.sent;
                _context9.next = 29;
                return this.sign(_freezeBalance2, options.privateKey || undefined);

              case 29:
                signedTransaction = _context9.sent;
                _context9.next = 32;
                return this.sendRawTransaction(signedTransaction);

              case 32:
                result = _context9.sent;
                return _context9.abrupt("return", callback(null, result));

              case 36:
                _context9.prev = 36;
                _context9.t0 = _context9["catch"](22);
                return _context9.abrupt("return", callback(_context9.t0));

              case 39:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this, [[22, 36]]);
      }));

      function freezeBalance() {
        return _freezeBalance.apply(this, arguments);
      }

      return freezeBalance;
    }()
    /**
     * Unfreeze MCASH that has passed the minimum freeze duration.
     * Unfreezing will remove bandwidth.
     *
     * @param resource - is the type, must be either "ENERGY" or "BANDWIDTH"
     * @param options
     * @param callback
     */

  }, {
    key: "unfreezeBalance",
    value: function () {
      var _unfreezeBalance = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee10() {
        var resource,
            options,
            receiverAddress,
            callback,
            address,
            _unfreezeBalance2,
            signedTransaction,
            result,
            _args10 = arguments;

        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                resource = _args10.length > 0 && _args10[0] !== undefined ? _args10[0] : "BANDWIDTH";
                options = _args10.length > 1 && _args10[1] !== undefined ? _args10[1] : {};
                receiverAddress = _args10.length > 2 && _args10[2] !== undefined ? _args10[2] : undefined;
                callback = _args10.length > 3 && _args10[3] !== undefined ? _args10[3] : false;

                if (_utils["default"].isFunction(receiverAddress)) {
                  callback = receiverAddress;
                  receiverAddress = undefined;
                }

                if (_utils["default"].isFunction(resource)) {
                  callback = resource;
                  resource = 'BANDWIDTH';
                }

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context10.next = 10;
                  break;
                }

                return _context10.abrupt("return", this.injectPromise(this.unfreezeBalance, resource, options, receiverAddress));

              case 10:
                if (['BANDWIDTH', 'ENERGY'].includes(resource)) {
                  _context10.next = 12;
                  break;
                }

                return _context10.abrupt("return", callback('Invalid resource provided: Expected "BANDWIDTH" or "ENERGY"'));

              case 12:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context10.next = 15;
                  break;
                }

                return _context10.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 15:
                _context10.prev = 15;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context10.next = 19;
                return this.mcashWeb.transactionBuilder.unfreezeBalance(resource, address, receiverAddress);

              case 19:
                _unfreezeBalance2 = _context10.sent;
                _context10.next = 22;
                return this.sign(_unfreezeBalance2, options.privateKey || undefined);

              case 22:
                signedTransaction = _context10.sent;
                _context10.next = 25;
                return this.sendRawTransaction(signedTransaction);

              case 25:
                result = _context10.sent;
                return _context10.abrupt("return", callback(null, result));

              case 29:
                _context10.prev = 29;
                _context10.t0 = _context10["catch"](15);
                return _context10.abrupt("return", callback(_context10.t0));

              case 32:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this, [[15, 29]]);
      }));

      function unfreezeBalance() {
        return _unfreezeBalance.apply(this, arguments);
      }

      return unfreezeBalance;
    }()
    /**
     * Unfreeze Asset that has passed the minimum freeze duration.
     *
     * @param options
     * @param callback
     */

  }, {
    key: "unfreezeAsset",
    value: function () {
      var _unfreezeAsset = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee11() {
        var options,
            callback,
            address,
            unfreezeAssetTransaction,
            signedTransaction,
            result,
            _args11 = arguments;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                options = _args11.length > 0 && _args11[0] !== undefined ? _args11[0] : {};
                callback = _args11.length > 1 && _args11[1] !== undefined ? _args11[1] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context11.next = 6;
                  break;
                }

                return _context11.abrupt("return", this.injectPromise(this.unfreezeAsset, options));

              case 6:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context11.next = 9;
                  break;
                }

                return _context11.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 9:
                _context11.prev = 9;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context11.next = 13;
                return this.mcashWeb.transactionBuilder.unfreezeAsset(address);

              case 13:
                unfreezeAssetTransaction = _context11.sent;
                _context11.next = 16;
                return this.sign(unfreezeAssetTransaction, options.privateKey || undefined);

              case 16:
                signedTransaction = _context11.sent;
                _context11.next = 19;
                return this.sendRawTransaction(signedTransaction);

              case 19:
                result = _context11.sent;
                return _context11.abrupt("return", callback(null, result));

              case 23:
                _context11.prev = 23;
                _context11.t0 = _context11["catch"](9);
                return _context11.abrupt("return", callback(_context11.t0));

              case 26:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this, [[9, 23]]);
      }));

      function unfreezeAsset() {
        return _unfreezeAsset.apply(this, arguments);
      }

      return unfreezeAsset;
    }()
    /**
     * Stake.
     * Will give voting power
     *
     * @param amount - is the number mcash
     * @param stakeDuration - is the duration in days to be staked
     * @param options
     * @param callback
     */

  }, {
    key: "stake",
    value: function () {
      var _stake = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee12() {
        var amount,
            stakeDuration,
            options,
            callback,
            address,
            stakeTransaction,
            signedTransaction,
            result,
            _args12 = arguments;
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                amount = _args12.length > 0 && _args12[0] !== undefined ? _args12[0] : 0;
                stakeDuration = _args12.length > 1 && _args12[1] !== undefined ? _args12[1] : 3;
                options = _args12.length > 2 && _args12[2] !== undefined ? _args12[2] : {};
                callback = _args12.length > 3 && _args12[3] !== undefined ? _args12[3] : false;

                if (_utils["default"].isFunction(stakeDuration)) {
                  callback = stakeDuration;
                  stakeDuration = 3;
                }

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context12.next = 9;
                  break;
                }

                return _context12.abrupt("return", this.injectPromise(this.stake, amount, stakeDuration, options));

              case 9:
                if (!(!_utils["default"].isInteger(amount) || amount <= 0)) {
                  _context12.next = 11;
                  break;
                }

                return _context12.abrupt("return", callback('Invalid amount provided'));

              case 11:
                if (!(!_utils["default"].isInteger(stakeDuration) || stakeDuration < 3)) {
                  _context12.next = 13;
                  break;
                }

                return _context12.abrupt("return", callback('Invalid duration provided, minimum of 3 days'));

              case 13:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context12.next = 16;
                  break;
                }

                return _context12.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 16:
                _context12.prev = 16;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context12.next = 20;
                return this.mcashWeb.transactionBuilder.stake(amount, stakeDuration, address);

              case 20:
                stakeTransaction = _context12.sent;
                _context12.next = 23;
                return this.sign(stakeTransaction, options.privateKey || undefined);

              case 23:
                signedTransaction = _context12.sent;
                _context12.next = 26;
                return this.sendRawTransaction(signedTransaction);

              case 26:
                result = _context12.sent;
                return _context12.abrupt("return", callback(null, result));

              case 30:
                _context12.prev = 30;
                _context12.t0 = _context12["catch"](16);
                return _context12.abrupt("return", callback(_context12.t0));

              case 33:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this, [[16, 30]]);
      }));

      function stake() {
        return _stake.apply(this, arguments);
      }

      return stake;
    }()
    /**
     * Unstake
     *
     * @param options
     * @param callback
     */

  }, {
    key: "unstake",
    value: function () {
      var _unstake = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee13() {
        var options,
            callback,
            address,
            unstakeTransaction,
            signedTransaction,
            result,
            _args13 = arguments;
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                options = _args13.length > 0 && _args13[0] !== undefined ? _args13[0] : {};
                callback = _args13.length > 1 && _args13[1] !== undefined ? _args13[1] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context13.next = 6;
                  break;
                }

                return _context13.abrupt("return", this.injectPromise(this.unstake, options));

              case 6:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context13.next = 9;
                  break;
                }

                return _context13.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 9:
                _context13.prev = 9;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context13.next = 13;
                return this.mcashWeb.transactionBuilder.unfreezeBalance(address);

              case 13:
                unstakeTransaction = _context13.sent;
                _context13.next = 16;
                return this.sign(unstakeTransaction, options.privateKey || undefined);

              case 16:
                signedTransaction = _context13.sent;
                _context13.next = 19;
                return this.sendRawTransaction(signedTransaction);

              case 19:
                result = _context13.sent;
                return _context13.abrupt("return", callback(null, result));

              case 23:
                _context13.prev = 23;
                _context13.t0 = _context13["catch"](9);
                return _context13.abrupt("return", callback(_context13.t0));

              case 26:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this, [[9, 23]]);
      }));

      function unstake() {
        return _unstake.apply(this, arguments);
      }

      return unstake;
    }()
    /**
     * Modify account name
     * Note: Username is allowed to edit only once.
     *
     * @param privateKey - Account private Key
     * @param accountName - name of the account
     * @param callback
     *
     * @return modified Transaction Object
     */

  }, {
    key: "updateAccount",
    value: function () {
      var _updateAccount = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee14() {
        var accountName,
            options,
            callback,
            address,
            _updateAccount2,
            signedTransaction,
            result,
            _args14 = arguments;

        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                accountName = _args14.length > 0 && _args14[0] !== undefined ? _args14[0] : false;
                options = _args14.length > 1 && _args14[1] !== undefined ? _args14[1] : {};
                callback = _args14.length > 2 && _args14[2] !== undefined ? _args14[2] : false;

                if (_utils["default"].isFunction(options)) {
                  callback = options;
                  options = {};
                }

                if (typeof options === 'string') options = {
                  privateKey: options
                };

                if (callback) {
                  _context14.next = 7;
                  break;
                }

                return _context14.abrupt("return", this.injectPromise(this.updateAccount, accountName, options));

              case 7:
                if (!(!_utils["default"].isString(accountName) || !accountName.length)) {
                  _context14.next = 9;
                  break;
                }

                return _context14.abrupt("return", callback('Name must be a string'));

              case 9:
                options = _objectSpread({
                  privateKey: this.mcashWeb.defaultPrivateKey,
                  address: this.mcashWeb.defaultAddress.hex
                }, options);

                if (!(!options.privateKey && !options.address)) {
                  _context14.next = 12;
                  break;
                }

                return _context14.abrupt("return", callback('Function requires either a private key or address to be set'));

              case 12:
                _context14.prev = 12;
                address = options.privateKey ? this.mcashWeb.address.fromPrivateKey(options.privateKey) : options.address;
                _context14.next = 16;
                return this.mcashWeb.transactionBuilder.updateAccount(accountName, address);

              case 16:
                _updateAccount2 = _context14.sent;
                _context14.next = 19;
                return this.sign(_updateAccount2, options.privateKey || undefined);

              case 19:
                signedTransaction = _context14.sent;
                _context14.next = 22;
                return this.sendRawTransaction(signedTransaction);

              case 22:
                result = _context14.sent;
                return _context14.abrupt("return", callback(null, result));

              case 26:
                _context14.prev = 26;
                _context14.t0 = _context14["catch"](12);
                return _context14.abrupt("return", callback(_context14.t0));

              case 29:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this, [[12, 26]]);
      }));

      function updateAccount() {
        return _updateAccount.apply(this, arguments);
      }

      return updateAccount;
    }()
  }, {
    key: "signMessage",
    value: function signMessage() {
      return this.sign.apply(this, arguments);
    }
  }, {
    key: "sendAsset",
    value: function sendAsset() {
      return this.sendToken.apply(this, arguments);
    }
  }, {
    key: "send",
    value: function send() {
      return this.sendTransaction.apply(this, arguments);
    }
  }, {
    key: "sendMcash",
    value: function sendMcash() {
      return this.sendTransaction.apply(this, arguments);
    }
  }, {
    key: "broadcast",
    value: function broadcast() {
      return this.sendRawTransaction.apply(this, arguments);
    }
  }, {
    key: "signTransaction",
    value: function signTransaction() {
      return this.sign.apply(this, arguments);
    }
    /**
     * Gets a network modification proposal by ID.
     */

  }, {
    key: "getProposal",
    value: function getProposal() {
      var proposalId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getProposal, proposalId);
      if (!_utils["default"].isInteger(proposalId) || proposalId < 0) return callback('Invalid proposalID provided');
      this.mcashWeb.fullNode.request('wallet/getproposalbyid', {
        id: proposalId
      }, 'post').then(function (proposal) {
        callback(null, proposal);
      })["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Lists all network modification proposals.
     */

  }, {
    key: "listProposals",
    value: function listProposals() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.listProposals);
      this.mcashWeb.fullNode.request('wallet/listproposals', {}, 'post').then(function (_ref17) {
        var _ref17$proposals = _ref17.proposals,
            proposals = _ref17$proposals === void 0 ? [] : _ref17$proposals;
        callback(null, proposals);
      })["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Lists all parameters available for network modification proposals.
     */

  }, {
    key: "getChainParameters",
    value: function getChainParameters() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.getChainParameters);
      this.mcashWeb.fullNode.request('wallet/getchainparameters', {}, 'post').then(function (_ref18) {
        var _ref18$chain_paramete = _ref18.chain_parameter,
            chain_parameter = _ref18$chain_paramete === void 0 ? [] : _ref18$chain_paramete;
        callback(null, chain_parameter);
      })["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Get the account resources
     */

  }, {
    key: "getAccountResources",
    value: function getAccountResources() {
      var address = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.mcashWeb.defaultAddress.hex;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getAccountResources, address);
      if (!this.mcashWeb.isAddress(address)) return callback('Invalid address provided');
      this.mcashWeb.fullNode.request('wallet/getaccountresource', {
        address: this.mcashWeb.address.toHex(address)
      }, 'post').then(function (resources) {
        callback(null, resources);
      })["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Get the exchange ID.
     */

  }, {
    key: "getExchangeByID",
    value: function getExchangeByID() {
      var exchangeId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getExchangeByID, exchangeId);
      if (!_utils["default"].isInteger(exchangeId) || exchangeId < 0) return callback('Invalid exchangeID provided');
      this.mcashWeb.fullNode.request('wallet/getexchangebyid', {
        id: exchangeId
      }, 'post').then(function (exchange) {
        callback(null, exchange);
      })["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Lists the exchanges
     */

  }, {
    key: "listExchanges",
    value: function listExchanges() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.listExchanges);
      this.mcashWeb.fullNode.request('wallet/listexchanges', {}, 'post').then(function (_ref19) {
        var _ref19$exchanges = _ref19.exchanges,
            exchanges = _ref19$exchanges === void 0 ? [] : _ref19$exchanges;
        callback(null, exchanges);
      }, 'post')["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Lists all network modification proposals.
     */

  }, {
    key: "listExchangesPaginated",
    value: function listExchangesPaginated() {
      var limit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (_utils["default"].isFunction(offset)) {
        callback = offset;
        offset = 0;
      }

      if (_utils["default"].isFunction(limit)) {
        callback = limit;
        limit = 30;
      }

      if (!callback) return this.injectPromise(this.listExchanges);
      this.mcashWeb.fullNode.request('wallet/listexchangespaginated', {
        limit: limit,
        offset: offset
      }, 'post').then(function (_ref20) {
        var _ref20$exchanges = _ref20.exchanges,
            exchanges = _ref20$exchanges === void 0 ? [] : _ref20$exchanges;
        callback(null, exchanges);
      })["catch"](function (err) {
        return callback(err);
      });
    }
    /**
     * Get info about node
     */

  }, {
    key: "getNodeInfo",
    value: function getNodeInfo() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!callback) return this.injectPromise(this.getNodeInfo);
      this.mcashWeb.fullNode.request('wallet/getnodeinfo', {}, 'post').then(function (info) {
        callback(null, info);
      }, 'post')["catch"](function (err) {
        return callback(err);
      });
    }
  }, {
    key: "getTokenById",
    value: function getTokenById() {
      var _this6 = this;

      var tokenId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (!callback) return this.injectPromise(this.getTokenById, tokenId);
      if (_utils["default"].isString(tokenId)) tokenId = parseInt(tokenId);
      if (!_utils["default"].isInteger(tokenId)) return callback('Invalid token ID provided');
      this.mcashWeb.fullNode.request('wallet/getassetissuebyid', {
        value: tokenId
      }, 'post').then(function (token) {
        if (!token.name) return callback('Token does not exist');
        callback(null, _this6._parseToken(token));
      })["catch"](function (err) {
        return callback(err);
      });
    }
  }], [{
    key: "verifySignature",
    value: function verifySignature(message, address, signature) {
      var useTronHeader = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      message = message.replace(/^0x/, '');
      signature = signature.replace(/^0x/, '');
      var messageBytes = [].concat((0, _toConsumableArray2["default"])((0, _ethersUtils.toUtf8Bytes)(useTronHeader ? MCASH_MESSAGE_HEADER : ETH_MESSAGE_HEADER)), (0, _toConsumableArray2["default"])(_utils["default"].code.hexStr2byteArray(message)));
      var messageDigest = (0, _ethersUtils.keccak256)(messageBytes);
      var recovered = (0, _ethersUtils.recoverAddress)(messageDigest, {
        recoveryParam: signature.substring(128, 130) == '1c' ? 1 : 0,
        r: '0x' + signature.substring(0, 64),
        s: '0x' + signature.substring(64, 128)
      });
      var tronAddress = _address.ADDRESS_PREFIX + recovered.substr(2);

      var base58Address = _index["default"].address.fromHex(tronAddress);

      return base58Address == _index["default"].address.fromHex(address);
    }
  }, {
    key: "signString",
    value: function signString(message, privateKey) {
      var useTronHeader = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      message = message.replace(/^0x/, '');
      var signingKey = new _ethersUtils.SigningKey(privateKey);
      var messageBytes = [].concat((0, _toConsumableArray2["default"])((0, _ethersUtils.toUtf8Bytes)(useTronHeader ? MCASH_MESSAGE_HEADER : ETH_MESSAGE_HEADER)), (0, _toConsumableArray2["default"])(_utils["default"].code.hexStr2byteArray(message)));
      var messageDigest = (0, _ethersUtils.keccak256)(messageBytes);
      var signature = signingKey.signDigest(messageDigest);
      var signatureHex = ['0x', signature.r.substring(2), signature.s.substring(2), Number(signature.v).toString(16)].join('');
      return signatureHex;
    }
  }]);
  return Mcash;
}();

exports["default"] = Mcash;
;
//# sourceMappingURL=mcash.js.map