"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _index = _interopRequireDefault(require("index"));

var _utils = _interopRequireDefault(require("utils"));

var _semver = _interopRequireDefault(require("semver"));

var Plugin =
/*#__PURE__*/
function () {
  function Plugin() {
    var mcashWeb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    (0, _classCallCheck2["default"])(this, Plugin);
    if (!mcashWeb || !mcashWeb instanceof _index["default"]) throw new Error('Expected instance of McashWeb');
    this.mcashWeb = mcashWeb;
    this.pluginNoOverride = ['register'];
  }

  (0, _createClass2["default"])(Plugin, [{
    key: "register",
    value: function register(Plugin, options) {
      var pluginInterface = {
        requires: '0.0.0',
        components: {}
      };
      var result = {
        plugged: [],
        skipped: []
      };
      var plugin = new Plugin(this.mcashWeb);

      if (_utils["default"].isFunction(plugin.pluginInterface)) {
        pluginInterface = plugin.pluginInterface(options);
      }

      if (_semver["default"].satisfies(_index["default"].version, pluginInterface.requires)) {
        for (var component in pluginInterface.components) {
          if (!this.mcashWeb.hasOwnProperty(component)) {
            // TODO implement new sub-classes
            continue;
          }

          var methods = pluginInterface.components[component];
          var pluginNoOverride = this.mcashWeb[component].pluginNoOverride || [];

          for (var method in methods) {
            if (method === 'constructor' || this.mcashWeb[component][method] && (pluginNoOverride.includes(method) // blacklisted methods
            || /^_/.test(method)) // private methods
            ) {
              result.skipped.push(method);
              continue;
            }

            this.mcashWeb[component][method] = methods[method].bind(this.mcashWeb[component]);
            result.plugged.push(method);
          }
        }
      } else {
        throw new Error('The plugin is not compatible with this version of McashWeb');
      }

      return result;
    }
  }]);
  return Plugin;
}();

exports["default"] = Plugin;
//# sourceMappingURL=plugin.js.map