"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _axios = _interopRequireDefault(require("axios"));

var _utils = _interopRequireDefault(require("utils"));

var HttpProvider =
/*#__PURE__*/
function () {
  function HttpProvider(host) {
    var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30000;
    var user = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var password = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    var headers = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    var statusPage = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : '/';
    (0, _classCallCheck2["default"])(this, HttpProvider);
    if (!_utils["default"].isValidURL(host)) throw new Error('Invalid URL provided to HttpProvider');
    if (isNaN(timeout) || timeout < 0) throw new Error('Invalid timeout duration provided');
    if (!_utils["default"].isObject(headers)) throw new Error('Invalid headers object provided');
    host = host.replace(/\/+$/, '');
    this.host = host;
    this.timeout = timeout;
    this.user = user;
    this.password = password;
    this.headers = headers;
    this.statusPage = statusPage;
    this.instance = _axios["default"].create({
      baseURL: host,
      timeout: timeout,
      headers: headers,
      auth: user && {
        user: user,
        password: password
      }
    });
  }

  (0, _createClass2["default"])(HttpProvider, [{
    key: "setStatusPage",
    value: function setStatusPage() {
      var statusPage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '/';
      this.statusPage = statusPage;
    }
  }, {
    key: "isConnected",
    value: function () {
      var _isConnected = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var statusPage,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                statusPage = _args.length > 0 && _args[0] !== undefined ? _args[0] : this.statusPage;
                return _context.abrupt("return", this.request(statusPage).then(function (data) {
                  return _utils["default"].hasProperties(data, 'block_id', 'block_header');
                })["catch"](function () {
                  return false;
                }));

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function isConnected() {
        return _isConnected.apply(this, arguments);
      }

      return isConnected;
    }()
  }, {
    key: "request",
    value: function request(url) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var method = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'get';
      method = method.toLowerCase();
      return this.instance.request({
        data: method == 'post' && Object.keys(payload).length ? payload : null,
        params: method == 'get' && payload,
        url: url,
        method: method
      }).then(function (_ref) {
        var data = _ref.data;
        return data;
      });
    }
  }]);
  return HttpProvider;
}();

exports["default"] = HttpProvider;
;
//# sourceMappingURL=HttpProvider.js.map