"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _index = _interopRequireDefault(require("index"));

var _utils = _interopRequireDefault(require("utils"));

var Validator =
/*#__PURE__*/
function () {
  function Validator() {
    var mcashWeb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    (0, _classCallCheck2["default"])(this, Validator);
    if (!mcashWeb || !mcashWeb instanceof _index["default"]) throw new Error('Expected instance of McashWeb');
    this.mcashWeb = mcashWeb;
  }

  (0, _createClass2["default"])(Validator, [{
    key: "invalid",
    value: function invalid(param) {
      return param.msg || "Invalid ".concat(param.name).concat(param.type === 'address' ? ' address' : '', " provided");
    }
  }, {
    key: "notPositive",
    value: function notPositive(param) {
      return "".concat(param.name, " must be a positive integer");
    }
  }, {
    key: "notEqual",
    value: function notEqual(param) {
      return param.msg || "".concat(param.names[0], " can not be equal to ").concat(param.names[1]);
    }
  }, {
    key: "notValid",
    value: function notValid() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new Function();
      var normalized = {};
      var no = false;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = params[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var param = _step.value;
          var name = param.name,
              names = param.names,
              value = param.value,
              type = param.type,
              gt = param.gt,
              lt = param.lt,
              gte = param.gte,
              lte = param.lte,
              se = param.se,
              optional = param.optional;
          if (optional && !_utils["default"].isNotNullOrUndefined(value)) continue;
          normalized[param.name] = param.value;

          switch (type) {
            case 'address':
              if (!this.mcashWeb.isAddress(value)) {
                no = true;
              } else {
                normalized[name] = this.mcashWeb.address.toHex(value);
              }

              break;

            case 'integer':
              if (!_utils["default"].isInteger(value) || typeof gt === 'number' && value <= param.gt || typeof lt === 'number' && value >= param.lt || typeof gte === 'number' && value < param.gte || typeof lte === 'number' && value > param.lte) {
                no = true;
              }

              break;

            case 'positive-integer':
              if (!_utils["default"].isInteger(value) || value <= 0) {
                callback(this.notPositive(param));
                return;
              }

              break;

            case 'tokenId':
              if (!_utils["default"].isInteger(value)) {
                no = true;
              }

              break;

            case 'notEmptyObject':
              if (!_utils["default"].isObject(value) || !Object.keys(value).length) {
                no = true;
              }

              break;

            case 'notEqual':
              if (normalized[names[0]] === normalized[names[1]]) {
                callback(this.notEqual(param));
                return true;
              }

              break;

            case 'resource':
              if (!['BANDWIDTH', 'ENERGY'].includes(value)) {
                no = true;
              }

              break;

            case 'url':
              if (!_utils["default"].isValidURL(value)) {
                no = true;
              }

              break;

            case 'hex':
              if (!_utils["default"].isHex(value)) {
                no = true;
              }

              break;

            case 'array':
              if (!Array.isArray(value)) {
                no = true;
              }

              break;

            case 'not-empty-string':
              if (!_utils["default"].isString(value) || !value.length) {
                no = true;
              }

              break;

            case 'boolean':
              if (!_utils["default"].isBoolean(value)) {
                no = true;
              }

              break;
          }

          if (no) {
            callback(this.invalid(param));
            return true;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return false;
    }
  }]);
  return Validator;
}();

exports["default"] = Validator;
//# sourceMappingURL=index.js.map