"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decodeParams = decodeParams;
exports.encodeParams = encodeParams;

var _ethersUtils = require("./ethersUtils");

var _index = _interopRequireDefault(require("index"));

var _address = require("utils/address");

var abiCoder = new _ethersUtils.AbiCoder();

function decodeParams(names, types, output, ignoreMethodHash) {
  if (!output || typeof output === 'boolean') {
    ignoreMethodHash = output;
    output = types;
    types = names;
    names = [];
  }

  if (ignoreMethodHash && output.replace(/^0x/, '').length % 64 === 8) output = '0x' + output.replace(/^0x/, '').substring(8);
  if (output.replace(/^0x/, '').length % 64) throw new Error('The encoded string is not valid. Its length must be a multiple of 64.');
  return abiCoder.decode(types, output).reduce(function (obj, arg, index) {
    if (types[index] == 'address') arg = _address.ADDRESS_PREFIX + arg.substr(2).toLowerCase();
    if (names.length) obj[names[index]] = arg;else obj.push(arg);
    return obj;
  }, names.length ? {} : []);
}

function encodeParams(types, values) {
  for (var i = 0; i < types.length; i++) {
    if (types[i] === 'address') {
      values[i] = _index["default"].address.toHex(values[i]).replace(_address.ADDRESS_PREFIX_REGEX, '0x');
    }
  }

  return abiCoder.encode(types, values);
}
//# sourceMappingURL=abi.js.map