"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateAccount = generateAccount;

var _bytes = require("./bytes");

var _crypto = require("./crypto");

function generateAccount() {
  var priKeyBytes = (0, _crypto.genPriKey)();
  var pubKeyBytes = (0, _crypto.getPubKeyFromPriKey)(priKeyBytes);
  var addressBytes = (0, _crypto.getAddressFromPriKey)(priKeyBytes);
  var privateKey = (0, _bytes.byteArray2hexStr)(priKeyBytes);
  var publicKey = (0, _bytes.byteArray2hexStr)(pubKeyBytes);
  return {
    privateKey: privateKey,
    publicKey: publicKey,
    address: {
      base58: (0, _crypto.getBase58CheckAddress)(addressBytes),
      hex: (0, _bytes.byteArray2hexStr)(addressBytes)
    }
  };
}
//# sourceMappingURL=accounts.js.map