"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hexStringToBase58 = hexStringToBase58;
exports.base58ToHexString = base58ToHexString;
exports.hexStringToUtf8 = hexStringToUtf8;
exports.stringUtf8tHex = stringUtf8tHex;
exports.address2HexString = address2HexString;
exports.hexString2Address = hexString2Address;
exports.hexString2Utf8 = hexString2Utf8;
exports.stringUtf8toHex = stringUtf8toHex;

var _code = require("./code");

var _address = require("utils/address");

var _crypto = require("./crypto");

function hexStringToBase58(sHexString) {
  if (sHexString.length < 2 || (sHexString.length & 1) != 0) return '';
  var bytes = (0, _code.hexStr2byteArray)(sHexString);
  return (0, _crypto.getBase58CheckAddress)(bytes);
}

function base58ToHexString(sBase58) {
  var bytes = (0, _crypto.decodeBase58Address)(sBase58);
  return (0, _crypto.byteArray2hexStr)(bytes);
}

function hexStringToUtf8(hex) {
  var arr = hex.split("");
  var out = "";

  for (var i = 0; i < arr.length / 2; i++) {
    var tmp = "0x".concat(arr[i * 2]).concat(arr[i * 2 + 1]);
    var charValue = String.fromCharCode(tmp);
    out += charValue;
  }

  return out;
}

function stringUtf8tHex(str) {
  var val = "";

  for (var i = 0; i < str.length; i++) {
    if (val == "") val = str.charCodeAt(i).toString(16);else val += str.charCodeAt(i).toString(16);
  }

  return val;
}

function address2HexString(sHexAddress) {
  if (sHexAddress.length == 42 && sHexAddress.indexOf(_address.ADDRESS_PREFIX) == 0) return sHexAddress;
  return base58ToHexString(sHexAddress);
}

function hexString2Address(sAddress) {
  return hexStringToBase58(sAddress);
}

function hexString2Utf8(sHexString) {
  return hexStringToUtf8(sHexString);
}

function stringUtf8toHex(sUtf8) {
  return stringUtf8tHex(sUtf8);
}
//# sourceMappingURL=help.js.map